#include "lvgl/lvgl.h"

#ifndef LV_ATTRIBUTE_MEM_ALIGN
#define LV_ATTRIBUTE_MEM_ALIGN
#endif

#ifndef LV_ATTRIBUTE_IMG_INSTAGRAM_32PX
#define LV_ATTRIBUTE_IMG_INSTAGRAM_32PX
#endif

const LV_ATTRIBUTE_MEM_ALIGN LV_ATTRIBUTE_IMG_INSTAGRAM_32PX uint8_t instagram_32px_map[] = {
#if LV_COLOR_DEPTH == 1 || LV_COLOR_DEPTH == 8
  /*Pixel format: Alpha 8 bit, Red: 3 bit, Green: 3 bit, Blue: 2 bit*/
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4f, 0x00, 0x4f, 0x14, 0x4f, 0x5f, 0x4f, 0x83, 0x4f, 0x8c, 0x6f, 0x94, 0x6f, 0x94, 0x6f, 0x97, 0x6f, 0x97, 0x6f, 0x97, 0x6f, 0x93, 0x6b, 0x9b, 0x6b, 0x9b, 0x6b, 0x9b, 0x6b, 0x93, 0x6b, 0x97, 0x6b, 0x97, 0x6b, 0x94, 0x8b, 0x90, 0x8b, 0x94, 0x8b, 0x94, 0x8b, 0x90, 0x8b, 0x80, 0x8b, 0x4f, 0x8b, 0x08, 0xa7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x2a, 0x00, 0x4f, 0x04, 0x4f, 0x78, 0x4f, 0xf8, 0x4f, 0xfb, 0x4f, 0xef, 0x6f, 0xff, 0x6f, 0xff, 0x6f, 0xff, 0x6f, 0xff, 0x6f, 0xff, 0x6b, 0xf7, 0x6b, 0xf8, 0x6b, 0xff, 0x6b, 0xff, 0x6b, 0xf3, 0x6b, 0xf7, 0x6b, 0xff, 0x6b, 0xfb, 0x8b, 0xf7, 0x8b, 0xff, 0x8b, 0xff, 0x8b, 0xff, 0x8b, 0xff, 0x8b, 0xfb, 0x8b, 0xf4, 0xa7, 0xdf, 0xa7, 0x54, 0x87, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x4f, 0x04, 0x4f, 0xb4, 0x4f, 0xff, 0x4f, 0xf4, 0x6f, 0xf7, 0x6f, 0xff, 0x6f, 0xff, 0x6f, 0xff, 0x6f, 0xff, 0x6f, 0xf7, 0x6b, 0xf7, 0x6b, 0xff, 0x6b, 0xff, 0x6b, 0xf4, 0x6b, 0xef, 0x6b, 0xff, 0x6b, 0xfc, 0x8b, 0xf4, 0x8b, 0xfc, 0x8b, 0xff, 0x8b, 0xff, 0x8b, 0xff, 0x8b, 0xfc, 0x8b, 0xf3, 0xab, 0xf3, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0x7b, 0x87, 0x00, 0x00, 0x00, 
  0x4f, 0x00, 0x4f, 0x78, 0x4f, 0xef, 0x6f, 0xf4, 0x6f, 0xff, 0x6f, 0xff, 0x6f, 0xff, 0x6f, 0xff, 0x6b, 0xf4, 0x6b, 0xf7, 0x6b, 0xff, 0x6b, 0xff, 0x6b, 0xf4, 0x6b, 0xf7, 0x6b, 0xfc, 0x6b, 0xfc, 0x8b, 0xf4, 0x8b, 0xfc, 0x8b, 0xff, 0x8b, 0xff, 0x8b, 0xff, 0x8b, 0xff, 0x8b, 0xf3, 0x8b, 0xf4, 0xa7, 0xfc, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0x48, 0x46, 0x00, 
  0x6f, 0x10, 0x6f, 0xf4, 0x6f, 0xff, 0x6f, 0xff, 0x6f, 0xff, 0x6f, 0xf0, 0x6b, 0xf7, 0x6b, 0xfb, 0x6b, 0xfc, 0xb7, 0xeb, 0xdb, 0xfc, 0xdb, 0xf0, 0xdb, 0xec, 0xdb, 0xf0, 0xfb, 0xef, 0xfb, 0xec, 0xfb, 0xf0, 0xfb, 0xf0, 0xfb, 0xf0, 0xfb, 0xf3, 0xfb, 0xf3, 0xdb, 0xf4, 0xd3, 0xef, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0xff, 0xab, 0xc7, 0x86, 0x00, 
  0x6f, 0x5f, 0x6f, 0xf8, 0x6b, 0xf7, 0x6b, 0xf7, 0x6b, 0xf4, 0x6b, 0xff, 0x6b, 0xf8, 0xdb, 0xf7, 0xff, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xd7, 0xf3, 0xa7, 0xff, 0xa7, 0xff, 0xa7, 0xf8, 0xab, 0xf7, 0xab, 0xf4, 0xab, 0xff, 0xcb, 0x2b, 
  0x6b, 0x7c, 0x6b, 0xfc, 0x6b, 0xff, 0x6b, 0xff, 0x6b, 0xff, 0x6b, 0xef, 0xff, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xff, 0xdb, 0xff, 0xdb, 0xff, 0xdb, 0xff, 0xdb, 0xff, 0xdb, 0xff, 0xdb, 0xff, 0xdb, 0xff, 0xdb, 0xff, 0xfb, 0xff, 0xfb, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xf0, 0xa7, 0xf7, 0xab, 0xf8, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0x58, 
  0x6b, 0x90, 0x6b, 0xf4, 0x6b, 0xf7, 0x8b, 0xf8, 0x8b, 0xf4, 0xfb, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xb3, 0xff, 0x8b, 0xff, 0x8b, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xa7, 0xff, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xf3, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0x67, 
  0x8b, 0x93, 0x8b, 0xff, 0x8b, 0xfc, 0x8b, 0xfb, 0x8b, 0xef, 0xff, 0xf7, 0xff, 0xff, 0xd3, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xcb, 0xff, 0xcb, 0xff, 0xcb, 0xff, 0xcb, 0xff, 0xfb, 0xff, 0xfb, 0xff, 0xab, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0x68, 
  0x8b, 0x8f, 0x8b, 0xef, 0x8b, 0xfc, 0x8b, 0xfc, 0xd7, 0xeb, 0xff, 0xff, 0xff, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xaa, 0xff, 0xab, 0xff, 0xaa, 0xff, 0xca, 0xff, 0xca, 0xff, 0xcf, 0xff, 0xcf, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xd7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd7, 0xff, 0xab, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xcb, 0xfc, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0x68, 
  0x8b, 0x94, 0x8b, 0xff, 0x8b, 0xff, 0xab, 0xf3, 0xfb, 0xf8, 0xff, 0xff, 0xfb, 0xff, 0xaa, 0xff, 0xaa, 0xff, 0xaa, 0xff, 0xaa, 0xff, 0xca, 0xff, 0xca, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xff, 0xca, 0xff, 0xd3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd3, 0xff, 0xcb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd3, 0xec, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0x68, 
  0xaa, 0x8f, 0xaa, 0xfb, 0xaa, 0xf7, 0xaa, 0xff, 0xfb, 0xf8, 0xff, 0xff, 0xfb, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xd2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xca, 0xff, 0xce, 0xff, 0xce, 0xff, 0xca, 0xff, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd7, 0xec, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0x6b, 
  0xaa, 0x94, 0xaa, 0xff, 0xaa, 0xf0, 0xca, 0xfb, 0xfb, 0xec, 0xff, 0xff, 0xfb, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xce, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xff, 0xee, 0xff, 0xee, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xec, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0x6b, 
  0xca, 0x93, 0xca, 0xf0, 0xca, 0xff, 0xca, 0xff, 0xfb, 0xf0, 0xff, 0xff, 0xfb, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xee, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xf2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf3, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xeb, 0xab, 0xff, 0xab, 0xff, 0xab, 0xff, 0xab, 0x6b, 
  0xca, 0x90, 0xca, 0xf8, 0xca, 0xf4, 0xe9, 0xec, 0xfb, 0xef, 0xff, 0xff, 0xfb, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xff, 0xe9, 0xff, 0xea, 0xff, 0xea, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xf4, 0xca, 0xf0, 0xab, 0xff, 0xab, 0xff, 0xab, 0x6b, 
  0xe9, 0x94, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xfb, 0xf0, 0xff, 0xff, 0xfb, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xee, 0xff, 0xff, 0xff, 0xff, 0xff, 0xee, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xee, 0xff, 0xca, 0xff, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xf4, 0xca, 0xff, 0xca, 0xf7, 0xab, 0xff, 0xab, 0x6c, 
  0xe9, 0x94, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xfb, 0xf0, 0xff, 0xff, 0xfb, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf2, 0xff, 0xed, 0xff, 0xed, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xea, 0xff, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xf3, 0xca, 0xff, 0xca, 0xfc, 0xcb, 0xfb, 0xab, 0x6c, 
  0xe9, 0x94, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xfb, 0xf0, 0xff, 0xff, 0xfb, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xed, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xfb, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xf3, 0xca, 0xff, 0xca, 0xff, 0xca, 0xf4, 0xab, 0x6c, 
  0xe9, 0x94, 0xe9, 0xff, 0xe9, 0xf3, 0xed, 0xf7, 0xff, 0xec, 0xff, 0xff, 0xfb, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xf6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf2, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf2, 0xff, 0xea, 0xff, 0xca, 0xff, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xf0, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0x6f, 
  0xe9, 0x8f, 0xed, 0xf7, 0xed, 0xff, 0xed, 0xff, 0xfb, 0xf4, 0xff, 0xff, 0xfb, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xff, 0xf7, 0xff, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xea, 0xff, 0xca, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xe8, 0xca, 0xff, 0xca, 0xff, 0xca, 0xff, 0xca, 0x6f, 
  0xed, 0x94, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xfb, 0xfb, 0xff, 0xff, 0xfb, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xf1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xea, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0xec, 0xca, 0xf3, 0xca, 0xff, 0xca, 0xff, 0xca, 0x6c, 
  0xed, 0x93, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xfb, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xed, 0xff, 0xf6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xff, 0xf2, 0xff, 0xe9, 0xff, 0xed, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf2, 0xf3, 0xca, 0xfb, 0xca, 0xfc, 0xca, 0xff, 0xca, 0x6c, 
  0xed, 0x93, 0xed, 0xff, 0xed, 0xff, 0xed, 0xf8, 0xf6, 0xe8, 0xff, 0xff, 0xff, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xed, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xee, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xca, 0xff, 0xca, 0xff, 0xca, 0xf4, 0xca, 0xff, 0xca, 0x6c, 
  0xed, 0x93, 0xed, 0xff, 0xf1, 0xf0, 0xf1, 0xfc, 0xf1, 0xff, 0xff, 0xf7, 0xff, 0xff, 0xfb, 0xff, 0xf5, 0xff, 0xf5, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xed, 0xff, 0xe9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0xca, 0xff, 0xca, 0xff, 0xca, 0xf7, 0xca, 0xfb, 0xca, 0x6b, 
  0xed, 0x8b, 0xf1, 0xf8, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xfb, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf5, 0xff, 0xf5, 0xff, 0xf5, 0xff, 0xf5, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xff, 0xed, 0xff, 0xed, 0xff, 0xed, 0xff, 0xe9, 0xff, 0xe9, 0xff, 0xf2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xf2, 0xf8, 0xca, 0xef, 0xca, 0xff, 0xca, 0xff, 0xca, 0xf7, 0xca, 0x67, 
  0xf1, 0x77, 0xf1, 0xff, 0xf1, 0xff, 0xf1, 0xfc, 0xf5, 0xf8, 0xf5, 0xfc, 0xff, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xf7, 0xf7, 0xe9, 0xff, 0xca, 0xf7, 0xca, 0xff, 0xca, 0xff, 0xca, 0xf4, 0xca, 0x54, 
  0xf1, 0x48, 0xf1, 0xff, 0xf1, 0xfb, 0xf5, 0xf8, 0xf5, 0xff, 0xf5, 0xfb, 0xf5, 0xf8, 0xfa, 0xf0, 0xff, 0xf8, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xff, 0xf7, 0xf2, 0xf8, 0xe9, 0xf8, 0xe9, 0xff, 0xe9, 0xf8, 0xca, 0xfc, 0xca, 0xff, 0xca, 0xfb, 0xca, 0x1b, 
  0xf0, 0x00, 0xf1, 0xd8, 0xf5, 0xf7, 0xf5, 0xff, 0xf5, 0xf7, 0xf9, 0xf4, 0xf9, 0xf8, 0xf9, 0xec, 0xf9, 0xeb, 0xf9, 0xec, 0xfa, 0xe4, 0xfe, 0xe4, 0xfb, 0xe0, 0xfb, 0xec, 0xfb, 0xe4, 0xfb, 0xe8, 0xfb, 0xe4, 0xfb, 0xec, 0xfb, 0xe4, 0xf6, 0xec, 0xf6, 0xe7, 0xf2, 0xf4, 0xed, 0xff, 0xe9, 0xf7, 0xe9, 0xff, 0xe9, 0xf3, 0xe9, 0xff, 0xe9, 0xff, 0xca, 0xf0, 0xca, 0xff, 0xca, 0xb3, 0xa5, 0x00, 
  0x88, 0x00, 0xf5, 0x4c, 0xf5, 0xff, 0xf5, 0xf7, 0xf9, 0xf3, 0xf9, 0xf7, 0xf9, 0xf0, 0xf9, 0xf7, 0xf9, 0xfc, 0xf9, 0xfb, 0xf9, 0xf0, 0xf9, 0xf7, 0xf9, 0xf0, 0xf5, 0xf0, 0xf5, 0xfb, 0xf5, 0xfc, 0xf5, 0xfb, 0xf1, 0xfb, 0xf1, 0xff, 0xed, 0xf4, 0xed, 0xf4, 0xed, 0xfc, 0xed, 0xff, 0xe9, 0xf3, 0xe9, 0xff, 0xe9, 0xff, 0xe9, 0xef, 0xe9, 0xff, 0xca, 0xf8, 0xca, 0xf7, 0xca, 0x27, 0x65, 0x00, 
  0x00, 0x00, 0xd1, 0x00, 0xf5, 0x6c, 0xf9, 0xf3, 0xf9, 0xf4, 0xf9, 0xf8, 0xf9, 0xff, 0xf9, 0xff, 0xf9, 0xff, 0xf9, 0xff, 0xf9, 0xff, 0xf9, 0xfc, 0xf9, 0xf7, 0xf9, 0xf0, 0xf5, 0xf4, 0xf5, 0xf4, 0xf5, 0xff, 0xf1, 0xf7, 0xf1, 0xff, 0xf1, 0xf7, 0xed, 0xff, 0xed, 0xef, 0xed, 0xff, 0xed, 0xff, 0xe9, 0xf8, 0xe9, 0xff, 0xe9, 0xfb, 0xe9, 0xff, 0xea, 0xe8, 0xca, 0x44, 0xc5, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0xd1, 0x00, 0xf9, 0x38, 0xf9, 0xbf, 0xf9, 0xff, 0xf9, 0xff, 0xf9, 0xff, 0xf9, 0xff, 0xf9, 0xff, 0xf9, 0xff, 0xf9, 0xff, 0xf9, 0xf8, 0xf9, 0xf0, 0xf9, 0xf0, 0xf5, 0xfc, 0xf5, 0xfc, 0xf5, 0xf4, 0xf1, 0xff, 0xf1, 0xf0, 0xed, 0xff, 0xed, 0xf0, 0xed, 0xff, 0xed, 0xff, 0xe9, 0xf8, 0xe9, 0xff, 0xe9, 0xf3, 0xe9, 0xa4, 0xe9, 0x23, 0xc5, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6d, 0x00, 0xd5, 0x00, 0xf9, 0x18, 0xf9, 0x4c, 0xf9, 0x5c, 0xf9, 0x63, 0xf9, 0x63, 0xf9, 0x64, 0xf9, 0x64, 0xf9, 0x67, 0xf9, 0x64, 0xf9, 0x58, 0xf5, 0x64, 0xf5, 0x63, 0xf5, 0x67, 0xf1, 0x63, 0xf1, 0x64, 0xed, 0x67, 0xed, 0x63, 0xed, 0x67, 0xed, 0x64, 0xe9, 0x5c, 0xe9, 0x47, 0xe9, 0x10, 0xa9, 0x00, 0x65, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
#endif
#if LV_COLOR_DEPTH == 16 && LV_COLOR_16_SWAP == 0
  /*Pixel format: Alpha 8 bit, Red: 5 bit, Green: 6 bit, Blue: 5 bit*/
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd6, 0x42, 0x00, 0x39, 0x4b, 0x14, 0x39, 0x4b, 0x5f, 0x39, 0x4b, 0x83, 0xd9, 0x52, 0x8c, 0xb9, 0x52, 0x94, 0xb9, 0x52, 0x94, 0xb9, 0x52, 0x97, 0xb9, 0x52, 0x97, 0xb9, 0x52, 0x97, 0x99, 0x5a, 0x93, 0x38, 0x6a, 0x9b, 0x38, 0x6a, 0x9b, 0x38, 0x6a, 0x9b, 0x19, 0x6a, 0x93, 0xf9, 0x71, 0x97, 0xf9, 0x71, 0x97, 0xf9, 0x71, 0x94, 0xd9, 0x71, 0x90, 0xb9, 0x79, 0x94, 0xb9, 0x79, 0x94, 0xb9, 0x79, 0x90, 0xb9, 0x79, 0x80, 0xb9, 0x79, 0x4f, 0xb9, 0x71, 0x08, 0x95, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x8d, 0x21, 0x00, 0x39, 0x4b, 0x04, 0x39, 0x4b, 0x78, 0x39, 0x4b, 0xf8, 0x39, 0x4b, 0xfb, 0xf9, 0x52, 0xef, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0x99, 0x5a, 0xf7, 0x38, 0x6a, 0xf8, 0x38, 0x6a, 0xff, 0x38, 0x6a, 0xff, 0x19, 0x6a, 0xf3, 0xf9, 0x71, 0xf7, 0xf9, 0x71, 0xff, 0xf9, 0x71, 0xfb, 0xd9, 0x71, 0xf7, 0xb9, 0x79, 0xff, 0xb9, 0x79, 0xff, 0xb9, 0x79, 0xff, 0xb9, 0x79, 0xff, 0xb9, 0x79, 0xfb, 0xb8, 0x81, 0xf4, 0x98, 0x91, 0xdf, 0x98, 0x99, 0x54, 0x55, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x39, 0x4b, 0x04, 0x39, 0x4b, 0xb4, 0x39, 0x4b, 0xff, 0x19, 0x4b, 0xf4, 0xd9, 0x52, 0xf7, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0x99, 0x5a, 0xf7, 0x59, 0x62, 0xf7, 0x38, 0x6a, 0xff, 0x38, 0x6a, 0xff, 0x19, 0x6a, 0xf4, 0xf9, 0x69, 0xef, 0xf9, 0x71, 0xff, 0xf9, 0x71, 0xfc, 0xd9, 0x71, 0xf4, 0xb9, 0x79, 0xfc, 0xb9, 0x79, 0xff, 0xb9, 0x79, 0xff, 0xb9, 0x79, 0xff, 0xb9, 0x79, 0xfc, 0xb9, 0x81, 0xf3, 0x98, 0x91, 0xf3, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0x7b, 0x34, 0x81, 0x00, 0x00, 0x00, 0x00, 
  0xb6, 0x42, 0x00, 0x39, 0x4b, 0x78, 0x19, 0x53, 0xef, 0xd9, 0x52, 0xf4, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0x99, 0x5a, 0xf4, 0x59, 0x62, 0xf7, 0x38, 0x6a, 0xff, 0x38, 0x6a, 0xff, 0x19, 0x6a, 0xf4, 0xf9, 0x69, 0xf7, 0xd9, 0x71, 0xfc, 0xd9, 0x71, 0xfc, 0xd9, 0x71, 0xf4, 0xb9, 0x79, 0xfc, 0xb9, 0x79, 0xff, 0xb9, 0x79, 0xff, 0xb9, 0x79, 0xff, 0xb9, 0x79, 0xff, 0xb9, 0x81, 0xf3, 0x98, 0x91, 0xf4, 0x98, 0x99, 0xfc, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0x48, 0xec, 0x48, 0x00, 
  0xb9, 0x52, 0x10, 0xb9, 0x52, 0xf4, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0xb9, 0x52, 0xff, 0x99, 0x5a, 0xf0, 0x79, 0x62, 0xf7, 0x39, 0x6a, 0xfb, 0x59, 0x6a, 0xfc, 0xfb, 0xac, 0xeb, 0xfc, 0xcd, 0xfc, 0x3d, 0xce, 0xf0, 0x3d, 0xd6, 0xec, 0x3d, 0xd6, 0xf0, 0x5d, 0xd6, 0xef, 0x9e, 0xde, 0xec, 0x7e, 0xde, 0xf0, 0x7e, 0xde, 0xf0, 0x7e, 0xde, 0xf0, 0x5d, 0xde, 0xf3, 0x3d, 0xd6, 0xf3, 0xfc, 0xd5, 0xf4, 0x3a, 0xbc, 0xef, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0xff, 0x97, 0xa1, 0xc7, 0x33, 0x91, 0x00, 
  0xb9, 0x52, 0x5f, 0xb9, 0x52, 0xf8, 0x99, 0x5a, 0xf7, 0x59, 0x62, 0xf7, 0x39, 0x6a, 0xf4, 0x38, 0x6a, 0xff, 0x19, 0x6a, 0xf8, 0x5d, 0xd6, 0xf7, 0xdf, 0xff, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xbf, 0xff, 0xf7, 0x7c, 0xd5, 0xf3, 0x57, 0x99, 0xff, 0x98, 0x99, 0xff, 0x98, 0x99, 0xf8, 0x97, 0xa1, 0xf7, 0xb6, 0xa9, 0xf4, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x2b, 
  0x59, 0x62, 0x7c, 0x38, 0x6a, 0xfc, 0x38, 0x6a, 0xff, 0x38, 0x6a, 0xff, 0x38, 0x6a, 0xff, 0x18, 0x72, 0xef, 0x3e, 0xef, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0xee, 0xff, 0x5d, 0xde, 0xff, 0xdc, 0xd5, 0xff, 0xdc, 0xcd, 0xff, 0xdc, 0xd5, 0xff, 0xbb, 0xd5, 0xff, 0x9b, 0xd5, 0xff, 0x9b, 0xd5, 0xff, 0x9b, 0xd5, 0xff, 0x9b, 0xd5, 0xff, 0xdc, 0xdd, 0xff, 0xfc, 0xdd, 0xff, 0x7d, 0xe6, 0xff, 0x5f, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x5d, 0xe6, 0xf0, 0x76, 0xa1, 0xf7, 0xb5, 0xb1, 0xf8, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x58, 
  0x38, 0x6a, 0x90, 0x18, 0x6a, 0xf4, 0x18, 0x72, 0xf7, 0xf8, 0x71, 0xf8, 0xf7, 0x79, 0xf4, 0x3c, 0xd6, 0xf7, 0xff, 0xff, 0xff, 0x9f, 0xff, 0xff, 0x5a, 0xac, 0xff, 0xd7, 0x89, 0xff, 0xf7, 0x91, 0xff, 0x17, 0x92, 0xff, 0x37, 0x9a, 0xff, 0xb6, 0x99, 0xff, 0xd6, 0x99, 0xff, 0x16, 0x9a, 0xff, 0xd6, 0x99, 0xff, 0x57, 0xaa, 0xff, 0x37, 0xaa, 0xff, 0xf7, 0xa9, 0xff, 0xd6, 0xa9, 0xff, 0xb6, 0xa1, 0xff, 0x76, 0xa1, 0xff, 0x5b, 0xd5, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfa, 0xd4, 0xf3, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x67, 
  0xf7, 0x79, 0x93, 0xf7, 0x79, 0xff, 0xf7, 0x79, 0xfc, 0xf7, 0x81, 0xfb, 0x17, 0x82, 0xef, 0xdf, 0xff, 0xf7, 0xff, 0xff, 0xff, 0x79, 0xbc, 0xff, 0x16, 0x9a, 0xff, 0xf6, 0x99, 0xff, 0x36, 0xa2, 0xff, 0xb5, 0x99, 0xff, 0xd5, 0x99, 0xff, 0x15, 0xa2, 0xff, 0xd5, 0xa1, 0xff, 0x15, 0xaa, 0xff, 0x35, 0xb2, 0xff, 0x56, 0xba, 0xff, 0x15, 0xb2, 0xff, 0xf5, 0xb1, 0xff, 0x15, 0xb2, 0xff, 0x9b, 0xdd, 0xff, 0xbb, 0xdd, 0xff, 0x16, 0xb2, 0xff, 0xdb, 0xdd, 0xff, 0xff, 0xff, 0xff, 0x3e, 0xf7, 0xf7, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x68, 
  0xd7, 0x81, 0x8f, 0xd6, 0x89, 0xef, 0xd6, 0x91, 0xfc, 0xd5, 0x91, 0xfc, 0xb9, 0xbc, 0xeb, 0xff, 0xff, 0xff, 0x1e, 0xf7, 0xff, 0xb5, 0x99, 0xff, 0xd4, 0xa1, 0xff, 0x55, 0xaa, 0xff, 0x14, 0xaa, 0xff, 0x54, 0xb2, 0xff, 0xf3, 0xb1, 0xff, 0x14, 0xb2, 0xff, 0x34, 0xb2, 0xff, 0xf5, 0xba, 0xff, 0xf5, 0xba, 0xff, 0xb3, 0xb1, 0xff, 0xf3, 0xb1, 0xff, 0x14, 0xba, 0xff, 0xd8, 0xd4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd9, 0xd4, 0xff, 0xb6, 0xb1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x36, 0xba, 0xfc, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x68, 
  0xd5, 0x91, 0x94, 0xd5, 0x91, 0xff, 0xd5, 0x91, 0xff, 0xd5, 0x99, 0xf3, 0xfb, 0xd5, 0xf8, 0xff, 0xff, 0xff, 0x5b, 0xe6, 0xff, 0x13, 0xaa, 0xff, 0xd2, 0xa9, 0xff, 0xd2, 0xa9, 0xff, 0xd2, 0xa9, 0xff, 0x32, 0xba, 0xff, 0x52, 0xba, 0xff, 0x5b, 0xe6, 0xff, 0x9e, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xdf, 0xff, 0xff, 0x5e, 0xff, 0xff, 0x58, 0xe5, 0xff, 0xf1, 0xc1, 0xff, 0x94, 0xcb, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xb5, 0xcb, 0xff, 0xf5, 0xb1, 0xff, 0x1e, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xd8, 0xc3, 0xec, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x68, 
  0xd3, 0xa1, 0x8f, 0xd3, 0xa9, 0xfb, 0xd2, 0xa9, 0xf7, 0xd2, 0xa9, 0xff, 0x1b, 0xe6, 0xf8, 0xff, 0xff, 0xff, 0xfa, 0xe5, 0xff, 0x31, 0xba, 0xff, 0xf0, 0xb9, 0xff, 0x30, 0xc2, 0xff, 0xf0, 0xc1, 0xff, 0xf4, 0xcb, 0xff, 0x9e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3d, 0xf7, 0xff, 0x32, 0xc2, 0xff, 0xb2, 0xca, 0xff, 0xb3, 0xca, 0xff, 0xf1, 0xc1, 0xff, 0x11, 0xc2, 0xff, 0xdd, 0xf6, 0xff, 0xff, 0xff, 0xff, 0xd9, 0xd4, 0xec, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x6b, 
  0xd2, 0xa9, 0x94, 0xd2, 0xa9, 0xff, 0xd1, 0xb1, 0xf0, 0xf0, 0xb9, 0xfb, 0x5b, 0xee, 0xec, 0xff, 0xff, 0xff, 0xb9, 0xe5, 0xff, 0x10, 0xc2, 0xff, 0x70, 0xc2, 0xff, 0x2e, 0xca, 0xff, 0xaf, 0xd2, 0xff, 0x9f, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7e, 0xff, 0xff, 0x16, 0xe5, 0xff, 0xef, 0xd2, 0xff, 0x30, 0xdb, 0xff, 0x97, 0xed, 0xff, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0xf6, 0xff, 0x31, 0xc2, 0xff, 0xf1, 0xc1, 0xff, 0xf1, 0xc1, 0xff, 0xf1, 0xc1, 0xff, 0xbc, 0xf6, 0xff, 0xff, 0xff, 0xff, 0x3a, 0xd5, 0xec, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x6b, 
  0xf0, 0xb9, 0x93, 0x0f, 0xc2, 0xf0, 0x0e, 0xc2, 0xff, 0xee, 0xc1, 0xff, 0x7b, 0xee, 0xf0, 0xff, 0xff, 0xff, 0xd8, 0xed, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x18, 0xee, 0xff, 0xff, 0xff, 0xff, 0x7e, 0xff, 0xff, 0xef, 0xd2, 0xff, 0x2d, 0xd2, 0xff, 0x2d, 0xd2, 0xff, 0x2d, 0xd2, 0xff, 0x2d, 0xd2, 0xff, 0xf2, 0xdb, 0xff, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0x95, 0xdc, 0xff, 0x51, 0xca, 0xff, 0xf1, 0xc1, 0xff, 0xf1, 0xc1, 0xff, 0xbc, 0xf6, 0xff, 0xff, 0xff, 0xff, 0x59, 0xdd, 0xeb, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x6b, 
  0x0e, 0xc2, 0x90, 0x0e, 0xca, 0xf8, 0x2d, 0xca, 0xf4, 0x2b, 0xd2, 0xec, 0x7a, 0xf6, 0xef, 0xff, 0xff, 0xff, 0xd8, 0xed, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x2b, 0xda, 0xff, 0x7e, 0xff, 0xff, 0xff, 0xff, 0xff, 0x35, 0xed, 0xff, 0x4b, 0xda, 0xff, 0x8c, 0xda, 0xff, 0x6d, 0xd2, 0xff, 0x6d, 0xd2, 0xff, 0x2d, 0xd2, 0xff, 0x2d, 0xd2, 0xff, 0x19, 0xee, 0xff, 0xff, 0xff, 0xff, 0x9b, 0xf6, 0xff, 0x0f, 0xca, 0xff, 0x51, 0xca, 0xff, 0xf1, 0xc1, 0xff, 0xbc, 0xee, 0xff, 0xff, 0xff, 0xff, 0x79, 0xdd, 0xf4, 0xd3, 0xb9, 0xf0, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x6b, 
  0x4b, 0xda, 0x94, 0x4a, 0xda, 0xff, 0x4a, 0xda, 0xff, 0x4a, 0xda, 0xff, 0x7a, 0xf6, 0xf0, 0xff, 0xff, 0xff, 0xd8, 0xed, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0xcd, 0xda, 0xff, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0x4e, 0xdb, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0xad, 0xd2, 0xff, 0x4d, 0xd2, 0xff, 0x36, 0xe5, 0xff, 0xff, 0xff, 0xff, 0x7e, 0xff, 0xff, 0xee, 0xc9, 0xff, 0x0f, 0xca, 0xff, 0x51, 0xca, 0xff, 0xbc, 0xee, 0xff, 0xff, 0xff, 0xff, 0x99, 0xe5, 0xf4, 0xf2, 0xc1, 0xff, 0xd4, 0xb9, 0xf7, 0xb5, 0xb1, 0xff, 0xb5, 0xb1, 0x6c, 
  0x4a, 0xda, 0x94, 0x4a, 0xda, 0xff, 0x4a, 0xda, 0xff, 0x4a, 0xda, 0xff, 0x7a, 0xf6, 0xf0, 0xff, 0xff, 0xff, 0xf7, 0xf5, 0xff, 0xea, 0xe2, 0xff, 0xc9, 0xe2, 0xff, 0x2b, 0xe3, 0xff, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xae, 0xe3, 0xff, 0x8a, 0xda, 0xff, 0xab, 0xda, 0xff, 0x6b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x8c, 0xda, 0xff, 0x56, 0xe5, 0xff, 0xff, 0xff, 0xff, 0x5d, 0xff, 0xff, 0xee, 0xc9, 0xff, 0x0f, 0xca, 0xff, 0x0f, 0xca, 0xff, 0xbc, 0xf6, 0xff, 0xff, 0xff, 0xff, 0x99, 0xdd, 0xf3, 0xf2, 0xc1, 0xff, 0xf2, 0xc1, 0xfc, 0xb5, 0xb1, 0xfb, 0xb5, 0xb1, 0x6c, 
  0x4a, 0xda, 0x94, 0x4a, 0xda, 0xff, 0x4a, 0xda, 0xff, 0x4a, 0xda, 0xff, 0x7a, 0xf6, 0xf0, 0xff, 0xff, 0xff, 0xf7, 0xf5, 0xff, 0xc8, 0xe2, 0xff, 0xc8, 0xe2, 0xff, 0xa7, 0xe2, 0xff, 0x5d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd7, 0xf5, 0xff, 0x69, 0xda, 0xff, 0x69, 0xda, 0xff, 0x89, 0xe2, 0xff, 0xab, 0xda, 0xff, 0x6b, 0xda, 0xff, 0x2b, 0xda, 0xff, 0x7a, 0xf6, 0xff, 0xff, 0xff, 0xff, 0x7a, 0xf6, 0xff, 0x4f, 0xca, 0xff, 0x0f, 0xca, 0xff, 0x0f, 0xca, 0xff, 0xbc, 0xf6, 0xff, 0xff, 0xff, 0xff, 0x79, 0xdd, 0xf3, 0xf2, 0xc1, 0xff, 0xf2, 0xc1, 0xff, 0xd2, 0xb9, 0xf4, 0xb5, 0xb1, 0x6c, 
  0x4a, 0xda, 0x94, 0x4a, 0xda, 0xff, 0x6a, 0xda, 0xf3, 0xc9, 0xe2, 0xf7, 0x99, 0xfe, 0xec, 0xff, 0xff, 0xff, 0xf7, 0xf5, 0xff, 0xc8, 0xe2, 0xff, 0xc8, 0xe2, 0xff, 0xc8, 0xe2, 0xff, 0x54, 0xf5, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xff, 0x30, 0xe4, 0xff, 0x69, 0xda, 0xff, 0x69, 0xda, 0xff, 0x69, 0xda, 0xff, 0x8a, 0xda, 0xff, 0x15, 0xed, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0xe3, 0xff, 0x6c, 0xda, 0xff, 0x4f, 0xca, 0xff, 0x0f, 0xca, 0xff, 0xbc, 0xf6, 0xff, 0xff, 0xff, 0xff, 0x58, 0xdd, 0xf0, 0xf2, 0xc1, 0xff, 0xf2, 0xc1, 0xff, 0xf2, 0xc1, 0xff, 0xd2, 0xb9, 0x6f, 
  0x8a, 0xda, 0x8f, 0xc9, 0xe2, 0xf7, 0x08, 0xe3, 0xff, 0x08, 0xe3, 0xff, 0x79, 0xfe, 0xf4, 0xff, 0xff, 0xff, 0x17, 0xf6, 0xff, 0x08, 0xe3, 0xff, 0xe8, 0xe2, 0xff, 0xe8, 0xe2, 0xff, 0x29, 0xeb, 0xff, 0x3c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xff, 0x38, 0xf6, 0xff, 0x55, 0xed, 0xff, 0x75, 0xed, 0xff, 0x9a, 0xf6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xf5, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x6c, 0xd2, 0xff, 0x2f, 0xca, 0xff, 0xdc, 0xf6, 0xff, 0xff, 0xff, 0xff, 0x78, 0xe5, 0xe8, 0xf2, 0xc1, 0xff, 0xf2, 0xc1, 0xff, 0xf2, 0xc1, 0xff, 0xd2, 0xc1, 0x6f, 
  0x08, 0xe3, 0x94, 0x08, 0xe3, 0xff, 0x08, 0xe3, 0xff, 0x08, 0xe3, 0xff, 0x38, 0xf6, 0xfb, 0xff, 0xff, 0xff, 0x58, 0xf6, 0xff, 0x28, 0xe3, 0xff, 0x28, 0xe3, 0xff, 0x28, 0xe3, 0xff, 0x28, 0xe3, 0xff, 0x8a, 0xeb, 0xff, 0xfb, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x38, 0xf6, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x6d, 0xd2, 0xff, 0xfc, 0xf6, 0xff, 0xff, 0xff, 0xff, 0xf6, 0xe4, 0xec, 0xf0, 0xc1, 0xf3, 0xf2, 0xc1, 0xff, 0xf2, 0xc1, 0xff, 0xf2, 0xc1, 0x6c, 
  0x08, 0xe3, 0x93, 0x08, 0xe3, 0xff, 0x08, 0xe3, 0xff, 0x08, 0xe3, 0xff, 0xf7, 0xf5, 0xfb, 0xff, 0xff, 0xff, 0xda, 0xfe, 0xff, 0x2b, 0xec, 0xff, 0x2a, 0xec, 0xff, 0x0a, 0xec, 0xff, 0xc9, 0xeb, 0xff, 0xca, 0xeb, 0xff, 0x69, 0xeb, 0xff, 0xd1, 0xec, 0xff, 0xba, 0xfe, 0xff, 0x5d, 0xff, 0xff, 0x5d, 0xff, 0xff, 0x59, 0xf6, 0xff, 0xce, 0xe3, 0xff, 0x88, 0xe2, 0xff, 0x8a, 0xe2, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x2a, 0xd2, 0xff, 0x5d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xb2, 0xdb, 0xf3, 0x0e, 0xca, 0xfb, 0xf1, 0xc1, 0xfc, 0xf2, 0xc1, 0xff, 0xf2, 0xc1, 0x6c, 
  0x08, 0xe3, 0x93, 0x08, 0xe3, 0xff, 0x08, 0xe3, 0xff, 0x28, 0xe3, 0xf8, 0x10, 0xed, 0xe8, 0xff, 0xff, 0xff, 0xbe, 0xff, 0xff, 0x08, 0xec, 0xff, 0x2a, 0xec, 0xff, 0x09, 0xec, 0xff, 0x2a, 0xec, 0xff, 0xe9, 0xeb, 0xff, 0xc9, 0xeb, 0xff, 0xea, 0xeb, 0xff, 0x68, 0xeb, 0xff, 0x27, 0xe3, 0xff, 0x28, 0xe3, 0xff, 0xa9, 0xe2, 0xff, 0x88, 0xe2, 0xff, 0x88, 0xe2, 0xff, 0x88, 0xe2, 0xff, 0xab, 0xe2, 0xff, 0x4b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x2e, 0xdb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x2e, 0xca, 0xff, 0x0e, 0xca, 0xff, 0xf0, 0xc1, 0xf4, 0xf2, 0xc1, 0xff, 0xf2, 0xc1, 0x6c, 
  0x08, 0xe3, 0x93, 0x08, 0xe3, 0xff, 0xc8, 0xeb, 0xf0, 0x49, 0xec, 0xfc, 0x49, 0xec, 0xff, 0xbe, 0xff, 0xf7, 0xff, 0xff, 0xff, 0x77, 0xf6, 0xff, 0xcb, 0xec, 0xff, 0xab, 0xec, 0xff, 0x49, 0xec, 0xff, 0x49, 0xec, 0xff, 0x4a, 0xec, 0xff, 0x09, 0xec, 0xff, 0xc9, 0xeb, 0xff, 0xa9, 0xeb, 0xff, 0x48, 0xe3, 0xff, 0x49, 0xe3, 0xff, 0xc9, 0xe2, 0xff, 0x88, 0xe2, 0xff, 0x88, 0xe2, 0xff, 0x88, 0xe2, 0xff, 0x8b, 0xda, 0xff, 0x4b, 0xda, 0xff, 0x9a, 0xf6, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xf6, 0xf0, 0x0e, 0xca, 0xff, 0x0e, 0xca, 0xff, 0x0e, 0xca, 0xf7, 0xf1, 0xc1, 0xfb, 0xf2, 0xc1, 0x6b, 
  0x28, 0xe3, 0x8b, 0x09, 0xec, 0xf8, 0x49, 0xec, 0xff, 0x49, 0xec, 0xff, 0x49, 0xec, 0xff, 0x36, 0xf6, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xb8, 0xfe, 0xff, 0x0b, 0xed, 0xff, 0xc9, 0xec, 0xff, 0xca, 0xec, 0xff, 0xaa, 0xec, 0xff, 0x29, 0xec, 0xff, 0x4a, 0xec, 0xff, 0xe9, 0xeb, 0xff, 0xca, 0xeb, 0xff, 0x28, 0xe3, 0xff, 0x49, 0xe3, 0xff, 0xa9, 0xe2, 0xff, 0x68, 0xe2, 0xff, 0x47, 0xe2, 0xff, 0xce, 0xe3, 0xff, 0x9b, 0xf6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0x12, 0xdc, 0xf8, 0x2e, 0xca, 0xef, 0x0e, 0xca, 0xff, 0x0e, 0xca, 0xff, 0xf1, 0xc1, 0xf7, 0xf2, 0xc1, 0x67, 
  0x49, 0xec, 0x77, 0x49, 0xec, 0xff, 0x49, 0xec, 0xff, 0x69, 0xec, 0xfc, 0xc9, 0xec, 0xf8, 0x29, 0xed, 0xfc, 0xf9, 0xfe, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x9d, 0xff, 0xff, 0x5c, 0xff, 0xff, 0x3b, 0xff, 0xff, 0x3b, 0xff, 0xff, 0x1b, 0xff, 0xff, 0x1b, 0xff, 0xff, 0x1b, 0xff, 0xff, 0xfb, 0xfe, 0xff, 0xfb, 0xfe, 0xff, 0xfb, 0xfe, 0xff, 0x1c, 0xff, 0xff, 0x7d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x15, 0xe5, 0xf7, 0x2c, 0xd2, 0xff, 0x2d, 0xd2, 0xf7, 0x0e, 0xca, 0xff, 0x0e, 0xca, 0xff, 0x0f, 0xca, 0xf4, 0xf2, 0xc1, 0x54, 
  0x49, 0xec, 0x48, 0x49, 0xec, 0xff, 0x69, 0xec, 0xfb, 0x0a, 0xed, 0xf8, 0x2a, 0xed, 0xff, 0x2a, 0xed, 0xfb, 0x49, 0xed, 0xf8, 0x94, 0xf6, 0xf0, 0x9c, 0xff, 0xf8, 0xff, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xdb, 0xf6, 0xf7, 0x10, 0xe4, 0xf8, 0x4b, 0xda, 0xf8, 0x2c, 0xd2, 0xff, 0x2c, 0xd2, 0xf8, 0x0e, 0xca, 0xfc, 0x0e, 0xca, 0xff, 0x0e, 0xca, 0xfb, 0xd2, 0xb9, 0x1b, 
  0x43, 0xfc, 0x00, 0x69, 0xec, 0xd8, 0x0a, 0xed, 0xf7, 0x2a, 0xed, 0xff, 0x4a, 0xf5, 0xf7, 0xaa, 0xf5, 0xf4, 0xca, 0xf5, 0xf8, 0xca, 0xf5, 0xec, 0xca, 0xf5, 0xeb, 0xeb, 0xf5, 0xec, 0x51, 0xf6, 0xe4, 0x93, 0xf6, 0xe4, 0x95, 0xf6, 0xe0, 0x75, 0xf6, 0xec, 0x55, 0xf6, 0xe4, 0x35, 0xf6, 0xe8, 0x15, 0xf6, 0xe4, 0xd5, 0xf5, 0xec, 0xd5, 0xf5, 0xe4, 0x53, 0xf5, 0xec, 0xd1, 0xec, 0xe7, 0xad, 0xeb, 0xf4, 0xa8, 0xe2, 0xff, 0x69, 0xda, 0xf7, 0x6a, 0xda, 0xff, 0x6a, 0xda, 0xf3, 0x2c, 0xd2, 0xff, 0x2c, 0xd2, 0xff, 0x2e, 0xca, 0xf0, 0x0e, 0xca, 0xff, 0x0e, 0xca, 0xb3, 0x6a, 0x91, 0x00, 
  0x24, 0x82, 0x00, 0x2a, 0xed, 0x4c, 0x2a, 0xed, 0xff, 0x6a, 0xf5, 0xf7, 0xca, 0xf5, 0xf3, 0xca, 0xf5, 0xf7, 0x0a, 0xf6, 0xf0, 0x4b, 0xf6, 0xf7, 0x6b, 0xf6, 0xfc, 0x4b, 0xf6, 0xfb, 0x2b, 0xf6, 0xf0, 0xea, 0xf5, 0xf7, 0xca, 0xf5, 0xf0, 0x6a, 0xf5, 0xf0, 0x4a, 0xf5, 0xfb, 0xc9, 0xec, 0xfc, 0xa9, 0xec, 0xfb, 0x09, 0xec, 0xfb, 0xe9, 0xeb, 0xff, 0x48, 0xe3, 0xf4, 0x28, 0xe3, 0xf4, 0x88, 0xe2, 0xfc, 0x88, 0xe2, 0xff, 0x88, 0xe2, 0xf3, 0x6a, 0xda, 0xff, 0x6a, 0xda, 0xff, 0x2b, 0xd2, 0xef, 0x2c, 0xd2, 0xff, 0x2d, 0xd2, 0xf8, 0x0e, 0xca, 0xf7, 0x0e, 0xca, 0x27, 0xe7, 0x68, 0x00, 
  0x00, 0x00, 0x00, 0x68, 0xd4, 0x00, 0x4a, 0xf5, 0x6c, 0xca, 0xf5, 0xf3, 0xca, 0xf5, 0xf4, 0x4b, 0xf6, 0xf8, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xfc, 0xea, 0xf5, 0xf7, 0xca, 0xf5, 0xf0, 0x6a, 0xf5, 0xf4, 0x2a, 0xed, 0xf4, 0xc9, 0xec, 0xff, 0x49, 0xec, 0xf7, 0xe9, 0xeb, 0xff, 0x88, 0xeb, 0xf7, 0x28, 0xe3, 0xff, 0xc8, 0xe2, 0xef, 0x88, 0xe2, 0xff, 0x88, 0xe2, 0xff, 0x6a, 0xda, 0xf8, 0x6a, 0xda, 0xff, 0x4b, 0xda, 0xfb, 0x2c, 0xd2, 0xff, 0x2c, 0xd2, 0xe8, 0x0e, 0xca, 0x44, 0x6a, 0xb1, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x67, 0xc4, 0x00, 0xca, 0xf5, 0x38, 0x4b, 0xf6, 0xbf, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xff, 0x6b, 0xf6, 0xff, 0x4b, 0xf6, 0xf8, 0xca, 0xf5, 0xf0, 0xaa, 0xf5, 0xf0, 0x4a, 0xf5, 0xfc, 0xc9, 0xec, 0xfc, 0xa9, 0xec, 0xf4, 0xe9, 0xeb, 0xff, 0xc8, 0xeb, 0xf0, 0x28, 0xe3, 0xff, 0x08, 0xe3, 0xf0, 0x88, 0xe2, 0xff, 0x88, 0xe2, 0xff, 0x69, 0xda, 0xf8, 0x6a, 0xda, 0xff, 0x4b, 0xda, 0xf3, 0x2c, 0xd2, 0xa4, 0x4c, 0xd2, 0x23, 0x69, 0xb1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa5, 0x62, 0x00, 0xa8, 0xb4, 0x00, 0x6b, 0xf6, 0x18, 0x6b, 0xf6, 0x4c, 0x6b, 0xf6, 0x5c, 0x6b, 0xf6, 0x63, 0x6b, 0xf6, 0x63, 0x6b, 0xf6, 0x64, 0x6b, 0xf6, 0x64, 0x6b, 0xf6, 0x67, 0x0b, 0xf6, 0x64, 0xca, 0xf5, 0x58, 0x4a, 0xf5, 0x64, 0xe9, 0xec, 0x63, 0xc9, 0xec, 0x67, 0x09, 0xec, 0x63, 0xe9, 0xeb, 0x64, 0x28, 0xe3, 0x67, 0x28, 0xe3, 0x63, 0xa8, 0xe2, 0x67, 0xa8, 0xe2, 0x64, 0x69, 0xda, 0x5c, 0x6a, 0xda, 0x47, 0x6a, 0xda, 0x10, 0xa8, 0x99, 0x00, 0x26, 0x71, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
#endif
#if LV_COLOR_DEPTH == 16 && LV_COLOR_16_SWAP != 0
  /*Pixel format: Alpha 8 bit, Red: 5 bit, Green: 6 bit, Blue: 5 bit  BUT the 2  color bytes are swapped*/
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0xd6, 0x00, 0x4b, 0x39, 0x14, 0x4b, 0x39, 0x5f, 0x4b, 0x39, 0x83, 0x52, 0xd9, 0x8c, 0x52, 0xb9, 0x94, 0x52, 0xb9, 0x94, 0x52, 0xb9, 0x97, 0x52, 0xb9, 0x97, 0x52, 0xb9, 0x97, 0x5a, 0x99, 0x93, 0x6a, 0x38, 0x9b, 0x6a, 0x38, 0x9b, 0x6a, 0x38, 0x9b, 0x6a, 0x19, 0x93, 0x71, 0xf9, 0x97, 0x71, 0xf9, 0x97, 0x71, 0xf9, 0x94, 0x71, 0xd9, 0x90, 0x79, 0xb9, 0x94, 0x79, 0xb9, 0x94, 0x79, 0xb9, 0x90, 0x79, 0xb9, 0x80, 0x79, 0xb9, 0x4f, 0x71, 0xb9, 0x08, 0xa0, 0x95, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x21, 0x8d, 0x00, 0x4b, 0x39, 0x04, 0x4b, 0x39, 0x78, 0x4b, 0x39, 0xf8, 0x4b, 0x39, 0xfb, 0x52, 0xf9, 0xef, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x5a, 0x99, 0xf7, 0x6a, 0x38, 0xf8, 0x6a, 0x38, 0xff, 0x6a, 0x38, 0xff, 0x6a, 0x19, 0xf3, 0x71, 0xf9, 0xf7, 0x71, 0xf9, 0xff, 0x71, 0xf9, 0xfb, 0x71, 0xd9, 0xf7, 0x79, 0xb9, 0xff, 0x79, 0xb9, 0xff, 0x79, 0xb9, 0xff, 0x79, 0xb9, 0xff, 0x79, 0xb9, 0xfb, 0x81, 0xb8, 0xf4, 0x91, 0x98, 0xdf, 0x99, 0x98, 0x54, 0x81, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x4b, 0x39, 0x04, 0x4b, 0x39, 0xb4, 0x4b, 0x39, 0xff, 0x4b, 0x19, 0xf4, 0x52, 0xd9, 0xf7, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x5a, 0x99, 0xf7, 0x62, 0x59, 0xf7, 0x6a, 0x38, 0xff, 0x6a, 0x38, 0xff, 0x6a, 0x19, 0xf4, 0x69, 0xf9, 0xef, 0x71, 0xf9, 0xff, 0x71, 0xf9, 0xfc, 0x71, 0xd9, 0xf4, 0x79, 0xb9, 0xfc, 0x79, 0xb9, 0xff, 0x79, 0xb9, 0xff, 0x79, 0xb9, 0xff, 0x79, 0xb9, 0xfc, 0x81, 0xb9, 0xf3, 0x91, 0x98, 0xf3, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0x7b, 0x81, 0x34, 0x00, 0x00, 0x00, 0x00, 
  0x42, 0xb6, 0x00, 0x4b, 0x39, 0x78, 0x53, 0x19, 0xef, 0x52, 0xd9, 0xf4, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x5a, 0x99, 0xf4, 0x62, 0x59, 0xf7, 0x6a, 0x38, 0xff, 0x6a, 0x38, 0xff, 0x6a, 0x19, 0xf4, 0x69, 0xf9, 0xf7, 0x71, 0xd9, 0xfc, 0x71, 0xd9, 0xfc, 0x71, 0xd9, 0xf4, 0x79, 0xb9, 0xfc, 0x79, 0xb9, 0xff, 0x79, 0xb9, 0xff, 0x79, 0xb9, 0xff, 0x79, 0xb9, 0xff, 0x81, 0xb9, 0xf3, 0x91, 0x98, 0xf4, 0x99, 0x98, 0xfc, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0x48, 0x48, 0xec, 0x00, 
  0x52, 0xb9, 0x10, 0x52, 0xb9, 0xf4, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x52, 0xb9, 0xff, 0x5a, 0x99, 0xf0, 0x62, 0x79, 0xf7, 0x6a, 0x39, 0xfb, 0x6a, 0x59, 0xfc, 0xac, 0xfb, 0xeb, 0xcd, 0xfc, 0xfc, 0xce, 0x3d, 0xf0, 0xd6, 0x3d, 0xec, 0xd6, 0x3d, 0xf0, 0xd6, 0x5d, 0xef, 0xde, 0x9e, 0xec, 0xde, 0x7e, 0xf0, 0xde, 0x7e, 0xf0, 0xde, 0x7e, 0xf0, 0xde, 0x5d, 0xf3, 0xd6, 0x3d, 0xf3, 0xd5, 0xfc, 0xf4, 0xbc, 0x3a, 0xef, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0xff, 0xa1, 0x97, 0xc7, 0x91, 0x33, 0x00, 
  0x52, 0xb9, 0x5f, 0x52, 0xb9, 0xf8, 0x5a, 0x99, 0xf7, 0x62, 0x59, 0xf7, 0x6a, 0x39, 0xf4, 0x6a, 0x38, 0xff, 0x6a, 0x19, 0xf8, 0xd6, 0x5d, 0xf7, 0xff, 0xdf, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xbf, 0xf7, 0xd5, 0x7c, 0xf3, 0x99, 0x57, 0xff, 0x99, 0x98, 0xff, 0x99, 0x98, 0xf8, 0xa1, 0x97, 0xf7, 0xa9, 0xb6, 0xf4, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x2b, 
  0x62, 0x59, 0x7c, 0x6a, 0x38, 0xfc, 0x6a, 0x38, 0xff, 0x6a, 0x38, 0xff, 0x6a, 0x38, 0xff, 0x72, 0x18, 0xef, 0xef, 0x3e, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xee, 0xfe, 0xff, 0xde, 0x5d, 0xff, 0xd5, 0xdc, 0xff, 0xcd, 0xdc, 0xff, 0xd5, 0xdc, 0xff, 0xd5, 0xbb, 0xff, 0xd5, 0x9b, 0xff, 0xd5, 0x9b, 0xff, 0xd5, 0x9b, 0xff, 0xd5, 0x9b, 0xff, 0xdd, 0xdc, 0xff, 0xdd, 0xfc, 0xff, 0xe6, 0x7d, 0xff, 0xf7, 0x5f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe6, 0x5d, 0xf0, 0xa1, 0x76, 0xf7, 0xb1, 0xb5, 0xf8, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x58, 
  0x6a, 0x38, 0x90, 0x6a, 0x18, 0xf4, 0x72, 0x18, 0xf7, 0x71, 0xf8, 0xf8, 0x79, 0xf7, 0xf4, 0xd6, 0x3c, 0xf7, 0xff, 0xff, 0xff, 0xff, 0x9f, 0xff, 0xac, 0x5a, 0xff, 0x89, 0xd7, 0xff, 0x91, 0xf7, 0xff, 0x92, 0x17, 0xff, 0x9a, 0x37, 0xff, 0x99, 0xb6, 0xff, 0x99, 0xd6, 0xff, 0x9a, 0x16, 0xff, 0x99, 0xd6, 0xff, 0xaa, 0x57, 0xff, 0xaa, 0x37, 0xff, 0xa9, 0xf7, 0xff, 0xa9, 0xd6, 0xff, 0xa1, 0xb6, 0xff, 0xa1, 0x76, 0xff, 0xd5, 0x5b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd4, 0xfa, 0xf3, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x67, 
  0x79, 0xf7, 0x93, 0x79, 0xf7, 0xff, 0x79, 0xf7, 0xfc, 0x81, 0xf7, 0xfb, 0x82, 0x17, 0xef, 0xff, 0xdf, 0xf7, 0xff, 0xff, 0xff, 0xbc, 0x79, 0xff, 0x9a, 0x16, 0xff, 0x99, 0xf6, 0xff, 0xa2, 0x36, 0xff, 0x99, 0xb5, 0xff, 0x99, 0xd5, 0xff, 0xa2, 0x15, 0xff, 0xa1, 0xd5, 0xff, 0xaa, 0x15, 0xff, 0xb2, 0x35, 0xff, 0xba, 0x56, 0xff, 0xb2, 0x15, 0xff, 0xb1, 0xf5, 0xff, 0xb2, 0x15, 0xff, 0xdd, 0x9b, 0xff, 0xdd, 0xbb, 0xff, 0xb2, 0x16, 0xff, 0xdd, 0xdb, 0xff, 0xff, 0xff, 0xff, 0xf7, 0x3e, 0xf7, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x68, 
  0x81, 0xd7, 0x8f, 0x89, 0xd6, 0xef, 0x91, 0xd6, 0xfc, 0x91, 0xd5, 0xfc, 0xbc, 0xb9, 0xeb, 0xff, 0xff, 0xff, 0xf7, 0x1e, 0xff, 0x99, 0xb5, 0xff, 0xa1, 0xd4, 0xff, 0xaa, 0x55, 0xff, 0xaa, 0x14, 0xff, 0xb2, 0x54, 0xff, 0xb1, 0xf3, 0xff, 0xb2, 0x14, 0xff, 0xb2, 0x34, 0xff, 0xba, 0xf5, 0xff, 0xba, 0xf5, 0xff, 0xb1, 0xb3, 0xff, 0xb1, 0xf3, 0xff, 0xba, 0x14, 0xff, 0xd4, 0xd8, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd4, 0xd9, 0xff, 0xb1, 0xb6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xba, 0x36, 0xfc, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x68, 
  0x91, 0xd5, 0x94, 0x91, 0xd5, 0xff, 0x91, 0xd5, 0xff, 0x99, 0xd5, 0xf3, 0xd5, 0xfb, 0xf8, 0xff, 0xff, 0xff, 0xe6, 0x5b, 0xff, 0xaa, 0x13, 0xff, 0xa9, 0xd2, 0xff, 0xa9, 0xd2, 0xff, 0xa9, 0xd2, 0xff, 0xba, 0x32, 0xff, 0xba, 0x52, 0xff, 0xe6, 0x5b, 0xff, 0xff, 0x9e, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xdf, 0xff, 0xff, 0x5e, 0xff, 0xe5, 0x58, 0xff, 0xc1, 0xf1, 0xff, 0xcb, 0x94, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xcb, 0xb5, 0xff, 0xb1, 0xf5, 0xff, 0xf7, 0x1e, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xd8, 0xec, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x68, 
  0xa1, 0xd3, 0x8f, 0xa9, 0xd3, 0xfb, 0xa9, 0xd2, 0xf7, 0xa9, 0xd2, 0xff, 0xe6, 0x1b, 0xf8, 0xff, 0xff, 0xff, 0xe5, 0xfa, 0xff, 0xba, 0x31, 0xff, 0xb9, 0xf0, 0xff, 0xc2, 0x30, 0xff, 0xc1, 0xf0, 0xff, 0xcb, 0xf4, 0xff, 0xff, 0x9e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7, 0x3d, 0xff, 0xc2, 0x32, 0xff, 0xca, 0xb2, 0xff, 0xca, 0xb3, 0xff, 0xc1, 0xf1, 0xff, 0xc2, 0x11, 0xff, 0xf6, 0xdd, 0xff, 0xff, 0xff, 0xff, 0xd4, 0xd9, 0xec, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x6b, 
  0xa9, 0xd2, 0x94, 0xa9, 0xd2, 0xff, 0xb1, 0xd1, 0xf0, 0xb9, 0xf0, 0xfb, 0xee, 0x5b, 0xec, 0xff, 0xff, 0xff, 0xe5, 0xb9, 0xff, 0xc2, 0x10, 0xff, 0xc2, 0x70, 0xff, 0xca, 0x2e, 0xff, 0xd2, 0xaf, 0xff, 0xff, 0x9f, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7e, 0xff, 0xe5, 0x16, 0xff, 0xd2, 0xef, 0xff, 0xdb, 0x30, 0xff, 0xed, 0x97, 0xff, 0xff, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xf6, 0xfd, 0xff, 0xc2, 0x31, 0xff, 0xc1, 0xf1, 0xff, 0xc1, 0xf1, 0xff, 0xc1, 0xf1, 0xff, 0xf6, 0xbc, 0xff, 0xff, 0xff, 0xff, 0xd5, 0x3a, 0xec, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x6b, 
  0xb9, 0xf0, 0x93, 0xc2, 0x0f, 0xf0, 0xc2, 0x0e, 0xff, 0xc1, 0xee, 0xff, 0xee, 0x7b, 0xf0, 0xff, 0xff, 0xff, 0xed, 0xd8, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xee, 0x18, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7e, 0xff, 0xd2, 0xef, 0xff, 0xd2, 0x2d, 0xff, 0xd2, 0x2d, 0xff, 0xd2, 0x2d, 0xff, 0xd2, 0x2d, 0xff, 0xdb, 0xf2, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xdc, 0x95, 0xff, 0xca, 0x51, 0xff, 0xc1, 0xf1, 0xff, 0xc1, 0xf1, 0xff, 0xf6, 0xbc, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x59, 0xeb, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x6b, 
  0xc2, 0x0e, 0x90, 0xca, 0x0e, 0xf8, 0xca, 0x2d, 0xf4, 0xd2, 0x2b, 0xec, 0xf6, 0x7a, 0xef, 0xff, 0xff, 0xff, 0xed, 0xd8, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x2b, 0xff, 0xff, 0x7e, 0xff, 0xff, 0xff, 0xff, 0xed, 0x35, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x8c, 0xff, 0xd2, 0x6d, 0xff, 0xd2, 0x6d, 0xff, 0xd2, 0x2d, 0xff, 0xd2, 0x2d, 0xff, 0xee, 0x19, 0xff, 0xff, 0xff, 0xff, 0xf6, 0x9b, 0xff, 0xca, 0x0f, 0xff, 0xca, 0x51, 0xff, 0xc1, 0xf1, 0xff, 0xee, 0xbc, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x79, 0xf4, 0xb9, 0xd3, 0xf0, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x6b, 
  0xda, 0x4b, 0x94, 0xda, 0x4a, 0xff, 0xda, 0x4a, 0xff, 0xda, 0x4a, 0xff, 0xf6, 0x7a, 0xf0, 0xff, 0xff, 0xff, 0xed, 0xd8, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xda, 0xcd, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xdb, 0x4e, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xd2, 0xad, 0xff, 0xd2, 0x4d, 0xff, 0xe5, 0x36, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7e, 0xff, 0xc9, 0xee, 0xff, 0xca, 0x0f, 0xff, 0xca, 0x51, 0xff, 0xee, 0xbc, 0xff, 0xff, 0xff, 0xff, 0xe5, 0x99, 0xf4, 0xc1, 0xf2, 0xff, 0xb9, 0xd4, 0xf7, 0xb1, 0xb5, 0xff, 0xb1, 0xb5, 0x6c, 
  0xda, 0x4a, 0x94, 0xda, 0x4a, 0xff, 0xda, 0x4a, 0xff, 0xda, 0x4a, 0xff, 0xf6, 0x7a, 0xf0, 0xff, 0xff, 0xff, 0xf5, 0xf7, 0xff, 0xe2, 0xea, 0xff, 0xe2, 0xc9, 0xff, 0xe3, 0x2b, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xe3, 0xae, 0xff, 0xda, 0x8a, 0xff, 0xda, 0xab, 0xff, 0xda, 0x6b, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x8c, 0xff, 0xe5, 0x56, 0xff, 0xff, 0xff, 0xff, 0xff, 0x5d, 0xff, 0xc9, 0xee, 0xff, 0xca, 0x0f, 0xff, 0xca, 0x0f, 0xff, 0xf6, 0xbc, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x99, 0xf3, 0xc1, 0xf2, 0xff, 0xc1, 0xf2, 0xfc, 0xb1, 0xb5, 0xfb, 0xb1, 0xb5, 0x6c, 
  0xda, 0x4a, 0x94, 0xda, 0x4a, 0xff, 0xda, 0x4a, 0xff, 0xda, 0x4a, 0xff, 0xf6, 0x7a, 0xf0, 0xff, 0xff, 0xff, 0xf5, 0xf7, 0xff, 0xe2, 0xc8, 0xff, 0xe2, 0xc8, 0xff, 0xe2, 0xa7, 0xff, 0xff, 0x5d, 0xff, 0xff, 0xff, 0xff, 0xf5, 0xd7, 0xff, 0xda, 0x69, 0xff, 0xda, 0x69, 0xff, 0xe2, 0x89, 0xff, 0xda, 0xab, 0xff, 0xda, 0x6b, 0xff, 0xda, 0x2b, 0xff, 0xf6, 0x7a, 0xff, 0xff, 0xff, 0xff, 0xf6, 0x7a, 0xff, 0xca, 0x4f, 0xff, 0xca, 0x0f, 0xff, 0xca, 0x0f, 0xff, 0xf6, 0xbc, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x79, 0xf3, 0xc1, 0xf2, 0xff, 0xc1, 0xf2, 0xff, 0xb9, 0xd2, 0xf4, 0xb1, 0xb5, 0x6c, 
  0xda, 0x4a, 0x94, 0xda, 0x4a, 0xff, 0xda, 0x6a, 0xf3, 0xe2, 0xc9, 0xf7, 0xfe, 0x99, 0xec, 0xff, 0xff, 0xff, 0xf5, 0xf7, 0xff, 0xe2, 0xc8, 0xff, 0xe2, 0xc8, 0xff, 0xe2, 0xc8, 0xff, 0xf5, 0x54, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xe4, 0x30, 0xff, 0xda, 0x69, 0xff, 0xda, 0x69, 0xff, 0xda, 0x69, 0xff, 0xda, 0x8a, 0xff, 0xed, 0x15, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe3, 0xf0, 0xff, 0xda, 0x6c, 0xff, 0xca, 0x4f, 0xff, 0xca, 0x0f, 0xff, 0xf6, 0xbc, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x58, 0xf0, 0xc1, 0xf2, 0xff, 0xc1, 0xf2, 0xff, 0xc1, 0xf2, 0xff, 0xb9, 0xd2, 0x6f, 
  0xda, 0x8a, 0x8f, 0xe2, 0xc9, 0xf7, 0xe3, 0x08, 0xff, 0xe3, 0x08, 0xff, 0xfe, 0x79, 0xf4, 0xff, 0xff, 0xff, 0xf6, 0x17, 0xff, 0xe3, 0x08, 0xff, 0xe2, 0xe8, 0xff, 0xe2, 0xe8, 0xff, 0xeb, 0x29, 0xff, 0xff, 0x3c, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xf6, 0x38, 0xff, 0xed, 0x55, 0xff, 0xed, 0x75, 0xff, 0xf6, 0x9a, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf5, 0xf8, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xd2, 0x6c, 0xff, 0xca, 0x2f, 0xff, 0xf6, 0xdc, 0xff, 0xff, 0xff, 0xff, 0xe5, 0x78, 0xe8, 0xc1, 0xf2, 0xff, 0xc1, 0xf2, 0xff, 0xc1, 0xf2, 0xff, 0xc1, 0xd2, 0x6f, 
  0xe3, 0x08, 0x94, 0xe3, 0x08, 0xff, 0xe3, 0x08, 0xff, 0xe3, 0x08, 0xff, 0xf6, 0x38, 0xfb, 0xff, 0xff, 0xff, 0xf6, 0x58, 0xff, 0xe3, 0x28, 0xff, 0xe3, 0x28, 0xff, 0xe3, 0x28, 0xff, 0xe3, 0x28, 0xff, 0xeb, 0x8a, 0xff, 0xfe, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf6, 0x38, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xd2, 0x6d, 0xff, 0xf6, 0xfc, 0xff, 0xff, 0xff, 0xff, 0xe4, 0xf6, 0xec, 0xc1, 0xf0, 0xf3, 0xc1, 0xf2, 0xff, 0xc1, 0xf2, 0xff, 0xc1, 0xf2, 0x6c, 
  0xe3, 0x08, 0x93, 0xe3, 0x08, 0xff, 0xe3, 0x08, 0xff, 0xe3, 0x08, 0xff, 0xf5, 0xf7, 0xfb, 0xff, 0xff, 0xff, 0xfe, 0xda, 0xff, 0xec, 0x2b, 0xff, 0xec, 0x2a, 0xff, 0xec, 0x0a, 0xff, 0xeb, 0xc9, 0xff, 0xeb, 0xca, 0xff, 0xeb, 0x69, 0xff, 0xec, 0xd1, 0xff, 0xfe, 0xba, 0xff, 0xff, 0x5d, 0xff, 0xff, 0x5d, 0xff, 0xf6, 0x59, 0xff, 0xe3, 0xce, 0xff, 0xe2, 0x88, 0xff, 0xe2, 0x8a, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xd2, 0x2a, 0xff, 0xff, 0x5d, 0xff, 0xff, 0xff, 0xff, 0xdb, 0xb2, 0xf3, 0xca, 0x0e, 0xfb, 0xc1, 0xf1, 0xfc, 0xc1, 0xf2, 0xff, 0xc1, 0xf2, 0x6c, 
  0xe3, 0x08, 0x93, 0xe3, 0x08, 0xff, 0xe3, 0x08, 0xff, 0xe3, 0x28, 0xf8, 0xed, 0x10, 0xe8, 0xff, 0xff, 0xff, 0xff, 0xbe, 0xff, 0xec, 0x08, 0xff, 0xec, 0x2a, 0xff, 0xec, 0x09, 0xff, 0xec, 0x2a, 0xff, 0xeb, 0xe9, 0xff, 0xeb, 0xc9, 0xff, 0xeb, 0xea, 0xff, 0xeb, 0x68, 0xff, 0xe3, 0x27, 0xff, 0xe3, 0x28, 0xff, 0xe2, 0xa9, 0xff, 0xe2, 0x88, 0xff, 0xe2, 0x88, 0xff, 0xe2, 0x88, 0xff, 0xe2, 0xab, 0xff, 0xda, 0x4b, 0xff, 0xda, 0x4b, 0xff, 0xdb, 0x2e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xca, 0x2e, 0xff, 0xca, 0x0e, 0xff, 0xc1, 0xf0, 0xf4, 0xc1, 0xf2, 0xff, 0xc1, 0xf2, 0x6c, 
  0xe3, 0x08, 0x93, 0xe3, 0x08, 0xff, 0xeb, 0xc8, 0xf0, 0xec, 0x49, 0xfc, 0xec, 0x49, 0xff, 0xff, 0xbe, 0xf7, 0xff, 0xff, 0xff, 0xf6, 0x77, 0xff, 0xec, 0xcb, 0xff, 0xec, 0xab, 0xff, 0xec, 0x49, 0xff, 0xec, 0x49, 0xff, 0xec, 0x4a, 0xff, 0xec, 0x09, 0xff, 0xeb, 0xc9, 0xff, 0xeb, 0xa9, 0xff, 0xe3, 0x48, 0xff, 0xe3, 0x49, 0xff, 0xe2, 0xc9, 0xff, 0xe2, 0x88, 0xff, 0xe2, 0x88, 0xff, 0xe2, 0x88, 0xff, 0xda, 0x8b, 0xff, 0xda, 0x4b, 0xff, 0xf6, 0x9a, 0xff, 0xff, 0xff, 0xff, 0xf6, 0xfc, 0xf0, 0xca, 0x0e, 0xff, 0xca, 0x0e, 0xff, 0xca, 0x0e, 0xf7, 0xc1, 0xf1, 0xfb, 0xc1, 0xf2, 0x6b, 
  0xe3, 0x28, 0x8b, 0xec, 0x09, 0xf8, 0xec, 0x49, 0xff, 0xec, 0x49, 0xff, 0xec, 0x49, 0xff, 0xf6, 0x36, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0xb8, 0xff, 0xed, 0x0b, 0xff, 0xec, 0xc9, 0xff, 0xec, 0xca, 0xff, 0xec, 0xaa, 0xff, 0xec, 0x29, 0xff, 0xec, 0x4a, 0xff, 0xeb, 0xe9, 0xff, 0xeb, 0xca, 0xff, 0xe3, 0x28, 0xff, 0xe3, 0x49, 0xff, 0xe2, 0xa9, 0xff, 0xe2, 0x68, 0xff, 0xe2, 0x47, 0xff, 0xe3, 0xce, 0xff, 0xf6, 0x9b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xdc, 0x12, 0xf8, 0xca, 0x2e, 0xef, 0xca, 0x0e, 0xff, 0xca, 0x0e, 0xff, 0xc1, 0xf1, 0xf7, 0xc1, 0xf2, 0x67, 
  0xec, 0x49, 0x77, 0xec, 0x49, 0xff, 0xec, 0x49, 0xff, 0xec, 0x69, 0xfc, 0xec, 0xc9, 0xf8, 0xed, 0x29, 0xfc, 0xfe, 0xf9, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x9d, 0xff, 0xff, 0x5c, 0xff, 0xff, 0x3b, 0xff, 0xff, 0x3b, 0xff, 0xff, 0x1b, 0xff, 0xff, 0x1b, 0xff, 0xff, 0x1b, 0xff, 0xfe, 0xfb, 0xff, 0xfe, 0xfb, 0xff, 0xfe, 0xfb, 0xff, 0xff, 0x1c, 0xff, 0xff, 0x7d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xe5, 0x15, 0xf7, 0xd2, 0x2c, 0xff, 0xd2, 0x2d, 0xf7, 0xca, 0x0e, 0xff, 0xca, 0x0e, 0xff, 0xca, 0x0f, 0xf4, 0xc1, 0xf2, 0x54, 
  0xec, 0x49, 0x48, 0xec, 0x49, 0xff, 0xec, 0x69, 0xfb, 0xed, 0x0a, 0xf8, 0xed, 0x2a, 0xff, 0xed, 0x2a, 0xfb, 0xed, 0x49, 0xf8, 0xf6, 0x94, 0xf0, 0xff, 0x9c, 0xf8, 0xff, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xf6, 0xdb, 0xf7, 0xe4, 0x10, 0xf8, 0xda, 0x4b, 0xf8, 0xd2, 0x2c, 0xff, 0xd2, 0x2c, 0xf8, 0xca, 0x0e, 0xfc, 0xca, 0x0e, 0xff, 0xca, 0x0e, 0xfb, 0xb9, 0xd2, 0x1b, 
  0xfc, 0x43, 0x00, 0xec, 0x69, 0xd8, 0xed, 0x0a, 0xf7, 0xed, 0x2a, 0xff, 0xf5, 0x4a, 0xf7, 0xf5, 0xaa, 0xf4, 0xf5, 0xca, 0xf8, 0xf5, 0xca, 0xec, 0xf5, 0xca, 0xeb, 0xf5, 0xeb, 0xec, 0xf6, 0x51, 0xe4, 0xf6, 0x93, 0xe4, 0xf6, 0x95, 0xe0, 0xf6, 0x75, 0xec, 0xf6, 0x55, 0xe4, 0xf6, 0x35, 0xe8, 0xf6, 0x15, 0xe4, 0xf5, 0xd5, 0xec, 0xf5, 0xd5, 0xe4, 0xf5, 0x53, 0xec, 0xec, 0xd1, 0xe7, 0xeb, 0xad, 0xf4, 0xe2, 0xa8, 0xff, 0xda, 0x69, 0xf7, 0xda, 0x6a, 0xff, 0xda, 0x6a, 0xf3, 0xd2, 0x2c, 0xff, 0xd2, 0x2c, 0xff, 0xca, 0x2e, 0xf0, 0xca, 0x0e, 0xff, 0xca, 0x0e, 0xb3, 0x91, 0x6a, 0x00, 
  0x82, 0x24, 0x00, 0xed, 0x2a, 0x4c, 0xed, 0x2a, 0xff, 0xf5, 0x6a, 0xf7, 0xf5, 0xca, 0xf3, 0xf5, 0xca, 0xf7, 0xf6, 0x0a, 0xf0, 0xf6, 0x4b, 0xf7, 0xf6, 0x6b, 0xfc, 0xf6, 0x4b, 0xfb, 0xf6, 0x2b, 0xf0, 0xf5, 0xea, 0xf7, 0xf5, 0xca, 0xf0, 0xf5, 0x6a, 0xf0, 0xf5, 0x4a, 0xfb, 0xec, 0xc9, 0xfc, 0xec, 0xa9, 0xfb, 0xec, 0x09, 0xfb, 0xeb, 0xe9, 0xff, 0xe3, 0x48, 0xf4, 0xe3, 0x28, 0xf4, 0xe2, 0x88, 0xfc, 0xe2, 0x88, 0xff, 0xe2, 0x88, 0xf3, 0xda, 0x6a, 0xff, 0xda, 0x6a, 0xff, 0xd2, 0x2b, 0xef, 0xd2, 0x2c, 0xff, 0xd2, 0x2d, 0xf8, 0xca, 0x0e, 0xf7, 0xca, 0x0e, 0x27, 0x68, 0xe7, 0x00, 
  0x00, 0x00, 0x00, 0xd4, 0x68, 0x00, 0xf5, 0x4a, 0x6c, 0xf5, 0xca, 0xf3, 0xf5, 0xca, 0xf4, 0xf6, 0x4b, 0xf8, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xfc, 0xf5, 0xea, 0xf7, 0xf5, 0xca, 0xf0, 0xf5, 0x6a, 0xf4, 0xed, 0x2a, 0xf4, 0xec, 0xc9, 0xff, 0xec, 0x49, 0xf7, 0xeb, 0xe9, 0xff, 0xeb, 0x88, 0xf7, 0xe3, 0x28, 0xff, 0xe2, 0xc8, 0xef, 0xe2, 0x88, 0xff, 0xe2, 0x88, 0xff, 0xda, 0x6a, 0xf8, 0xda, 0x6a, 0xff, 0xda, 0x4b, 0xfb, 0xd2, 0x2c, 0xff, 0xd2, 0x2c, 0xe8, 0xca, 0x0e, 0x44, 0xb1, 0x6a, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc4, 0x67, 0x00, 0xf5, 0xca, 0x38, 0xf6, 0x4b, 0xbf, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xff, 0xf6, 0x6b, 0xff, 0xf6, 0x4b, 0xf8, 0xf5, 0xca, 0xf0, 0xf5, 0xaa, 0xf0, 0xf5, 0x4a, 0xfc, 0xec, 0xc9, 0xfc, 0xec, 0xa9, 0xf4, 0xeb, 0xe9, 0xff, 0xeb, 0xc8, 0xf0, 0xe3, 0x28, 0xff, 0xe3, 0x08, 0xf0, 0xe2, 0x88, 0xff, 0xe2, 0x88, 0xff, 0xda, 0x69, 0xf8, 0xda, 0x6a, 0xff, 0xda, 0x4b, 0xf3, 0xd2, 0x2c, 0xa4, 0xd2, 0x4c, 0x23, 0xb1, 0x69, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x62, 0xa5, 0x00, 0xb4, 0xa8, 0x00, 0xf6, 0x6b, 0x18, 0xf6, 0x6b, 0x4c, 0xf6, 0x6b, 0x5c, 0xf6, 0x6b, 0x63, 0xf6, 0x6b, 0x63, 0xf6, 0x6b, 0x64, 0xf6, 0x6b, 0x64, 0xf6, 0x6b, 0x67, 0xf6, 0x0b, 0x64, 0xf5, 0xca, 0x58, 0xf5, 0x4a, 0x64, 0xec, 0xe9, 0x63, 0xec, 0xc9, 0x67, 0xec, 0x09, 0x63, 0xeb, 0xe9, 0x64, 0xe3, 0x28, 0x67, 0xe3, 0x28, 0x63, 0xe2, 0xa8, 0x67, 0xe2, 0xa8, 0x64, 0xda, 0x69, 0x5c, 0xda, 0x6a, 0x47, 0xda, 0x6a, 0x10, 0x99, 0xa8, 0x00, 0x71, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
#endif
#if LV_COLOR_DEPTH == 32
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb3, 0x58, 0x42, 0x00, 0xca, 0x65, 0x4c, 0x14, 0xca, 0x65, 0x4b, 0x5f, 0xca, 0x65, 0x4b, 0x83, 0xcb, 0x5a, 0x50, 0x8c, 0xcb, 0x54, 0x53, 0x94, 0xcb, 0x54, 0x53, 0x94, 0xcb, 0x54, 0x53, 0x97, 0xcb, 0x54, 0x53, 0x97, 0xcb, 0x54, 0x53, 0x97, 0xca, 0x51, 0x58, 0x93, 0xc4, 0x43, 0x67, 0x9b, 0xc4, 0x43, 0x67, 0x9b, 0xc4, 0x43, 0x67, 0x9b, 0xc5, 0x42, 0x68, 0x93, 0xc8, 0x3c, 0x6d, 0x97, 0xc9, 0x3b, 0x6e, 0x97, 0xc9, 0x3b, 0x6e, 0x94, 0xc8, 0x38, 0x73, 0x90, 0xc7, 0x36, 0x77, 0x94, 0xc7, 0x36, 0x77, 0x94, 0xc7, 0x36, 0x77, 0x90, 0xc7, 0x36, 0x77, 0x80, 0xc7, 0x36, 0x77, 0x4f, 0xca, 0x35, 0x74, 0x08, 0xab, 0x12, 0xa2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x6a, 0x32, 0x23, 0x00, 0xcb, 0x65, 0x49, 0x04, 0xca, 0x65, 0x4b, 0x78, 0xca, 0x65, 0x4b, 0xf8, 0xca, 0x65, 0x4b, 0xfb, 0xca, 0x5e, 0x4e, 0xef, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xc9, 0x4f, 0x59, 0xf7, 0xc4, 0x44, 0x66, 0xf8, 0xc4, 0x43, 0x67, 0xff, 0xc4, 0x43, 0x67, 0xff, 0xc5, 0x41, 0x69, 0xf3, 0xc9, 0x3c, 0x6e, 0xf7, 0xc9, 0x3b, 0x6e, 0xff, 0xc9, 0x3b, 0x6f, 0xfb, 0xc8, 0x38, 0x73, 0xf7, 0xc7, 0x36, 0x77, 0xff, 0xc7, 0x36, 0x77, 0xff, 0xc7, 0x36, 0x77, 0xff, 0xc7, 0x36, 0x77, 0xff, 0xc7, 0x36, 0x77, 0xfb, 0xc4, 0x34, 0x82, 0xf4, 0xbe, 0x30, 0x94, 0xdf, 0xbd, 0x2f, 0x97, 0x54, 0xa8, 0x2a, 0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0xc8, 0x66, 0x4b, 0x04, 0xca, 0x65, 0x4b, 0xb4, 0xca, 0x65, 0x4b, 0xff, 0xca, 0x62, 0x4c, 0xf4, 0xcb, 0x58, 0x51, 0xf7, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xca, 0x52, 0x56, 0xf7, 0xc6, 0x48, 0x62, 0xf7, 0xc4, 0x43, 0x67, 0xff, 0xc4, 0x43, 0x67, 0xff, 0xc5, 0x42, 0x68, 0xf4, 0xc8, 0x3d, 0x6c, 0xef, 0xc9, 0x3b, 0x6e, 0xff, 0xc9, 0x3b, 0x6e, 0xfc, 0xc8, 0x39, 0x72, 0xf4, 0xc7, 0x36, 0x77, 0xfc, 0xc7, 0x36, 0x77, 0xff, 0xc7, 0x36, 0x77, 0xff, 0xc7, 0x36, 0x77, 0xff, 0xc7, 0x36, 0x77, 0xfc, 0xc5, 0x35, 0x7e, 0xf3, 0xbf, 0x31, 0x91, 0xf3, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0x7b, 0xa4, 0x26, 0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0xb3, 0x53, 0x43, 0x00, 0xca, 0x64, 0x4b, 0x78, 0xca, 0x60, 0x4d, 0xef, 0xcb, 0x58, 0x51, 0xf4, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xca, 0x50, 0x58, 0xf4, 0xc6, 0x48, 0x62, 0xf7, 0xc4, 0x43, 0x67, 0xff, 0xc4, 0x43, 0x67, 0xff, 0xc5, 0x41, 0x68, 0xf4, 0xc8, 0x3d, 0x6c, 0xf7, 0xc9, 0x3a, 0x6e, 0xfc, 0xc9, 0x3a, 0x6e, 0xfc, 0xc8, 0x38, 0x72, 0xf4, 0xc7, 0x35, 0x76, 0xfc, 0xc7, 0x35, 0x77, 0xff, 0xc7, 0x35, 0x77, 0xff, 0xc7, 0x35, 0x77, 0xff, 0xc7, 0x36, 0x77, 0xff, 0xc5, 0x35, 0x7e, 0xf3, 0xbf, 0x31, 0x90, 0xf4, 0xbd, 0x2f, 0x97, 0xfc, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0x48, 0x63, 0x1c, 0x4a, 0x00, 
  0xcb, 0x55, 0x53, 0x10, 0xcb, 0x55, 0x53, 0xf4, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xcb, 0x54, 0x53, 0xff, 0xca, 0x52, 0x56, 0xf0, 0xc7, 0x4b, 0x5f, 0xf7, 0xc5, 0x45, 0x65, 0xfb, 0xc5, 0x4a, 0x6c, 0xfc, 0xda, 0x9c, 0xa9, 0xeb, 0xe4, 0xbe, 0xc5, 0xfc, 0xe8, 0xc4, 0xcc, 0xf0, 0xea, 0xc5, 0xcf, 0xec, 0xe9, 0xc3, 0xcd, 0xf0, 0xeb, 0xc8, 0xd2, 0xef, 0xee, 0xd0, 0xda, 0xec, 0xee, 0xce, 0xda, 0xf0, 0xed, 0xcd, 0xd9, 0xf0, 0xed, 0xcc, 0xd8, 0xf0, 0xec, 0xc9, 0xd6, 0xf3, 0xea, 0xc6, 0xd3, 0xf3, 0xe3, 0xbd, 0xd0, 0xf4, 0xd1, 0x83, 0xb8, 0xef, 0xbd, 0x30, 0x98, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xb8, 0x31, 0x9e, 0xc7, 0x9c, 0x24, 0x90, 0x00, 
  0xcb, 0x54, 0x53, 0x5f, 0xcb, 0x54, 0x53, 0xf8, 0xc9, 0x4f, 0x59, 0xf7, 0xc7, 0x4a, 0x5f, 0xf7, 0xc5, 0x45, 0x65, 0xf4, 0xc4, 0x43, 0x67, 0xff, 0xc5, 0x40, 0x67, 0xf8, 0xe9, 0xc9, 0xcf, 0xf7, 0xfe, 0xfa, 0xfb, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfa, 0xf3, 0xf8, 0xf7, 0xdd, 0xae, 0xcd, 0xf3, 0xbc, 0x29, 0x95, 0xff, 0xbd, 0x2f, 0x97, 0xff, 0xbd, 0x2f, 0x97, 0xf8, 0xb5, 0x32, 0xa2, 0xf7, 0xae, 0x34, 0xac, 0xf4, 0xaa, 0x35, 0xb0, 0xff, 0xab, 0x36, 0xb1, 0x2b, 
  0xc6, 0x47, 0x64, 0x7c, 0xc4, 0x44, 0x67, 0xfc, 0xc4, 0x43, 0x67, 0xff, 0xc4, 0x43, 0x67, 0xff, 0xc4, 0x43, 0x67, 0xff, 0xc3, 0x40, 0x6d, 0xef, 0xf4, 0xe3, 0xe7, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0xde, 0xe8, 0xff, 0xe5, 0xc8, 0xd6, 0xff, 0xe0, 0xba, 0xcd, 0xff, 0xde, 0xb7, 0xca, 0xff, 0xe0, 0xb7, 0xce, 0xff, 0xdc, 0xb3, 0xcd, 0xff, 0xdb, 0xb2, 0xce, 0xff, 0xdb, 0xb2, 0xce, 0xff, 0xdb, 0xb2, 0xcd, 0xff, 0xdb, 0xb2, 0xcd, 0xff, 0xdf, 0xb7, 0xd5, 0xff, 0xe0, 0xbc, 0xd8, 0xff, 0xe5, 0xcc, 0xe0, 0xff, 0xf5, 0xe7, 0xf2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe9, 0xca, 0xde, 0xf0, 0xb1, 0x2b, 0xa4, 0xf7, 0xab, 0x35, 0xaf, 0xf8, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0x58, 
  0xc4, 0x43, 0x67, 0x90, 0xc2, 0x42, 0x6b, 0xf4, 0xc0, 0x40, 0x6f, 0xf7, 0xbe, 0x3e, 0x74, 0xf8, 0xba, 0x3b, 0x7a, 0xf4, 0xe4, 0xc5, 0xd2, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xf9, 0xf2, 0xf6, 0xff, 0xcd, 0x87, 0xac, 0xff, 0xb7, 0x37, 0x86, 0xff, 0xb8, 0x3e, 0x8d, 0xff, 0xba, 0x42, 0x93, 0xff, 0xb8, 0x43, 0x9a, 0xff, 0xb2, 0x36, 0x96, 0xff, 0xb2, 0x38, 0x97, 0xff, 0xb3, 0x3f, 0x9a, 0xff, 0xb2, 0x3a, 0x9b, 0xff, 0xba, 0x49, 0xa6, 0xff, 0xb9, 0x43, 0xa8, 0xff, 0xb6, 0x3b, 0xa6, 0xff, 0xb4, 0x39, 0xa5, 0xff, 0xb3, 0x35, 0xa4, 0xff, 0xb2, 0x2c, 0xa3, 0xff, 0xd7, 0xa8, 0xd1, 0xff, 0xfd, 0xfb, 0xfd, 0xff, 0xff, 0xff, 0xff, 0xff, 0xcd, 0x9d, 0xd1, 0xf3, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0x67, 
  0xba, 0x3b, 0x7b, 0x93, 0xba, 0x3b, 0x7b, 0xff, 0xba, 0x3b, 0x7b, 0xfc, 0xb8, 0x3b, 0x7d, 0xfb, 0xb8, 0x40, 0x84, 0xef, 0xfd, 0xf9, 0xfb, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xcb, 0x8b, 0xb9, 0xff, 0xb4, 0x40, 0x9b, 0xff, 0xaf, 0x3c, 0x9a, 0xff, 0xaf, 0x44, 0x9f, 0xff, 0xa6, 0x36, 0x99, 0xff, 0xa6, 0x38, 0x9b, 0xff, 0xa8, 0x40, 0xa0, 0xff, 0xa5, 0x3a, 0xa0, 0xff, 0xa8, 0x42, 0xa8, 0xff, 0xab, 0x46, 0xae, 0xff, 0xad, 0x49, 0xb5, 0xff, 0xaa, 0x40, 0xb2, 0xff, 0xa9, 0x3d, 0xb2, 0xff, 0xaa, 0x41, 0xb1, 0xff, 0xd7, 0xb2, 0xd8, 0xff, 0xd8, 0xb5, 0xd9, 0xff, 0xad, 0x41, 0xb0, 0xff, 0xd9, 0xb7, 0xdb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf1, 0xe6, 0xf2, 0xf7, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0x68, 
  0xb5, 0x3a, 0x82, 0x8f, 0xb1, 0x39, 0x87, 0xef, 0xad, 0x38, 0x8d, 0xfc, 0xab, 0x38, 0x8f, 0xfc, 0xc9, 0x93, 0xb9, 0xeb, 0xff, 0xff, 0xff, 0xff, 0xef, 0xe0, 0xed, 0xff, 0xa5, 0x35, 0x9b, 0xff, 0xa4, 0x39, 0x9d, 0xff, 0xa6, 0x48, 0xa7, 0xff, 0xa0, 0x3f, 0xa7, 0xff, 0xa2, 0x48, 0xb0, 0xff, 0x9b, 0x3c, 0xae, 0xff, 0x9d, 0x42, 0xb1, 0xff, 0xa0, 0x45, 0xb4, 0xff, 0xa8, 0x5e, 0xba, 0xff, 0xa8, 0x5c, 0xba, 0xff, 0x9a, 0x36, 0xb2, 0xff, 0x9c, 0x3c, 0xb3, 0xff, 0x9e, 0x42, 0xb5, 0xff, 0xc3, 0x9a, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xcb, 0x98, 0xce, 0xff, 0xad, 0x36, 0xb0, 0xff, 0xfe, 0xfb, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xaf, 0x45, 0xb5, 0xfc, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0x68, 
  0xab, 0x38, 0x8f, 0x94, 0xab, 0x38, 0x8f, 0xff, 0xab, 0x38, 0x90, 0xff, 0xa5, 0x38, 0x97, 0xf3, 0xd5, 0xbc, 0xd4, 0xf8, 0xff, 0xff, 0xff, 0xff, 0xdc, 0xca, 0xe1, 0xff, 0x97, 0x3f, 0xab, 0xff, 0x94, 0x3a, 0xab, 0xff, 0x93, 0x38, 0xaa, 0xff, 0x91, 0x39, 0xac, 0xff, 0x93, 0x45, 0xb5, 0xff, 0x91, 0x49, 0xb8, 0xff, 0xd9, 0xc7, 0xe1, 0xff, 0xf4, 0xef, 0xf6, 0xff, 0xfc, 0xfa, 0xfd, 0xff, 0xfc, 0xf9, 0xfd, 0xff, 0xef, 0xe9, 0xf6, 0xff, 0xc3, 0xa7, 0xdd, 0xff, 0x89, 0x3d, 0xc0, 0xff, 0xa1, 0x71, 0xcb, 0xff, 0xfd, 0xfb, 0xfe, 0xff, 0xfc, 0xfa, 0xfd, 0xff, 0xa7, 0x74, 0xcb, 0xff, 0xa8, 0x3c, 0xb4, 0xff, 0xf0, 0xdf, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x77, 0xc4, 0xec, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0x68, 
  0x9c, 0x39, 0xa1, 0x8f, 0x97, 0x39, 0xa6, 0xfb, 0x90, 0x39, 0xac, 0xf7, 0x90, 0x39, 0xac, 0xff, 0xd5, 0xc1, 0xde, 0xf8, 0xff, 0xff, 0xff, 0xff, 0xd0, 0xbc, 0xdf, 0xff, 0x8b, 0x45, 0xba, 0xff, 0x83, 0x3e, 0xba, 0xff, 0x83, 0x44, 0xbf, 0xff, 0x7e, 0x3d, 0xbe, 0xff, 0x9d, 0x7c, 0xca, 0xff, 0xf4, 0xf1, 0xf9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xeb, 0xe3, 0xf3, 0xff, 0x8d, 0x43, 0xc3, 0xff, 0x94, 0x54, 0xc5, 0xff, 0x95, 0x56, 0xc6, 0xff, 0x89, 0x3b, 0xc0, 0xff, 0x8b, 0x3f, 0xc0, 0xff, 0xe5, 0xd8, 0xed, 0xff, 0xff, 0xff, 0xff, 0xff, 0xcb, 0x99, 0xcf, 0xec, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0x6b, 
  0x90, 0x39, 0xac, 0x94, 0x91, 0x39, 0xac, 0xff, 0x8b, 0x3a, 0xb0, 0xf0, 0x84, 0x3b, 0xb6, 0xfb, 0xd8, 0xca, 0xe7, 0xec, 0xff, 0xff, 0xff, 0xff, 0xc8, 0xb6, 0xe0, 0xff, 0x81, 0x3f, 0xbd, 0xff, 0x83, 0x4d, 0xc3, 0xff, 0x74, 0x43, 0xc6, 0xff, 0x7c, 0x55, 0xcd, 0xff, 0xf5, 0xf2, 0xf9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xee, 0xec, 0xf8, 0xff, 0xad, 0xa1, 0xe1, 0xff, 0x7a, 0x5d, 0xd4, 0xff, 0x80, 0x66, 0xd5, 0xff, 0xba, 0xb1, 0xe5, 0xff, 0xf6, 0xf4, 0xfc, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe5, 0xdd, 0xf1, 0xff, 0x8a, 0x45, 0xc3, 0xff, 0x89, 0x3c, 0xc0, 0xff, 0x89, 0x3c, 0xc0, 0xff, 0x89, 0x3b, 0xc0, 0xff, 0xe1, 0xd5, 0xed, 0xff, 0xff, 0xff, 0xff, 0xff, 0xcf, 0xa4, 0xd2, 0xec, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0x6b, 
  0x7f, 0x3d, 0xba, 0x93, 0x75, 0x3f, 0xc1, 0xf0, 0x74, 0x3f, 0xc2, 0xff, 0x74, 0x3e, 0xc2, 0xff, 0xd6, 0xcc, 0xea, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xc1, 0xb9, 0xe9, 0xff, 0x5a, 0x49, 0xd5, 0xff, 0x57, 0x47, 0xd5, 0xff, 0x58, 0x47, 0xd5, 0xff, 0xc3, 0xbf, 0xec, 0xff, 0xff, 0xff, 0xff, 0xff, 0xee, 0xed, 0xfa, 0xff, 0x76, 0x5c, 0xd4, 0xff, 0x66, 0x44, 0xce, 0xff, 0x66, 0x44, 0xce, 0xff, 0x66, 0x44, 0xce, 0xff, 0x66, 0x44, 0xce, 0xff, 0x8e, 0x7b, 0xd8, 0xff, 0xfa, 0xf9, 0xfd, 0xff, 0xff, 0xff, 0xff, 0xff, 0xa7, 0x8f, 0xd8, 0xff, 0x88, 0x47, 0xc5, 0xff, 0x89, 0x3b, 0xc0, 0xff, 0x89, 0x3c, 0xc0, 0xff, 0xe0, 0xd5, 0xed, 0xff, 0xff, 0xff, 0xff, 0xff, 0xcb, 0xa9, 0xd7, 0xeb, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0x6b, 
  0x74, 0x3f, 0xc2, 0x90, 0x6f, 0x41, 0xc6, 0xf8, 0x67, 0x43, 0xcb, 0xf4, 0x5c, 0x45, 0xd1, 0xec, 0xcf, 0xcd, 0xf1, 0xef, 0xff, 0xff, 0xff, 0xff, 0xbd, 0xb9, 0xea, 0xff, 0x59, 0x48, 0xd5, 0xff, 0x59, 0x48, 0xd5, 0xff, 0x58, 0x46, 0xd5, 0xff, 0xee, 0xee, 0xf9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xaa, 0xa4, 0xe6, 0xff, 0x58, 0x48, 0xd5, 0xff, 0x62, 0x50, 0xd6, 0xff, 0x67, 0x4e, 0xd3, 0xff, 0x6a, 0x4b, 0xd0, 0xff, 0x66, 0x44, 0xce, 0xff, 0x66, 0x44, 0xce, 0xff, 0xc8, 0xc1, 0xea, 0xff, 0xff, 0xff, 0xff, 0xff, 0xda, 0xd1, 0xee, 0xff, 0x75, 0x40, 0xc8, 0xff, 0x86, 0x48, 0xc7, 0xff, 0x89, 0x3c, 0xc0, 0xff, 0xe0, 0xd4, 0xec, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc5, 0xac, 0xdb, 0xf4, 0x9a, 0x39, 0xb8, 0xf0, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0x6b, 
  0x55, 0x49, 0xd6, 0x94, 0x53, 0x49, 0xd7, 0xff, 0x53, 0x49, 0xd7, 0xff, 0x53, 0x49, 0xd7, 0xff, 0xce, 0xcc, 0xf1, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xbd, 0xb9, 0xea, 0xff, 0x59, 0x48, 0xd5, 0xff, 0x59, 0x48, 0xd5, 0xff, 0x67, 0x59, 0xd7, 0xff, 0xf8, 0xf7, 0xfd, 0xff, 0xff, 0xff, 0xff, 0xff, 0x73, 0x68, 0xdc, 0xff, 0x59, 0x49, 0xd5, 0xff, 0x58, 0x48, 0xd5, 0xff, 0x58, 0x48, 0xd5, 0xff, 0x5a, 0x4a, 0xd5, 0xff, 0x6b, 0x54, 0xd4, 0xff, 0x68, 0x47, 0xcf, 0xff, 0xae, 0xa4, 0xe0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xef, 0xec, 0xf7, 0xff, 0x73, 0x3b, 0xc8, 0xff, 0x76, 0x42, 0xc8, 0xff, 0x85, 0x48, 0xc7, 0xff, 0xdf, 0xd4, 0xec, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc7, 0xb1, 0xdd, 0xf4, 0x8d, 0x3b, 0xbe, 0xff, 0xa0, 0x37, 0xb5, 0xf7, 0xaa, 0x35, 0xb0, 0xff, 0xaa, 0x35, 0xb0, 0x6c, 
  0x53, 0x49, 0xd7, 0x94, 0x53, 0x49, 0xd7, 0xff, 0x53, 0x49, 0xd7, 0xff, 0x53, 0x49, 0xd7, 0xff, 0xce, 0xcc, 0xf1, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xbb, 0xbd, 0xf0, 0xff, 0x51, 0x5c, 0xe0, 0xff, 0x4a, 0x59, 0xe1, 0xff, 0x5c, 0x66, 0xe2, 0xff, 0xf6, 0xf7, 0xfd, 0xff, 0xff, 0xff, 0xff, 0xff, 0x71, 0x74, 0xe2, 0xff, 0x50, 0x52, 0xdc, 0xff, 0x5a, 0x55, 0xdb, 0xff, 0x59, 0x4b, 0xd6, 0xff, 0x58, 0x48, 0xd5, 0xff, 0x58, 0x48, 0xd5, 0xff, 0x62, 0x50, 0xd6, 0xff, 0xb2, 0xaa, 0xe4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xec, 0xe8, 0xf6, 0xff, 0x73, 0x3b, 0xc8, 0xff, 0x75, 0x41, 0xc8, 0xff, 0x75, 0x41, 0xc8, 0xff, 0xdd, 0xd5, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc6, 0xaf, 0xdc, 0xf3, 0x8d, 0x3b, 0xbe, 0xff, 0x8e, 0x3b, 0xbe, 0xfc, 0xa6, 0x36, 0xb2, 0xfb, 0xaa, 0x35, 0xb0, 0x6c, 
  0x53, 0x49, 0xd7, 0x94, 0x53, 0x49, 0xd7, 0xff, 0x53, 0x49, 0xd7, 0xff, 0x53, 0x49, 0xd7, 0xff, 0xce, 0xcd, 0xf1, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xb7, 0xbc, 0xf1, 0xff, 0x3d, 0x57, 0xe3, 0xff, 0x3d, 0x57, 0xe3, 0xff, 0x38, 0x54, 0xe3, 0xff, 0xe7, 0xe8, 0xfa, 0xff, 0xff, 0xff, 0xff, 0xff, 0xb5, 0xb7, 0xed, 0xff, 0x48, 0x4d, 0xdc, 0xff, 0x48, 0x4d, 0xdc, 0xff, 0x4c, 0x50, 0xdd, 0xff, 0x57, 0x54, 0xdb, 0xff, 0x5a, 0x4c, 0xd6, 0xff, 0x57, 0x46, 0xd5, 0xff, 0xd0, 0xcd, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd0, 0xcb, 0xef, 0xff, 0x78, 0x49, 0xcb, 0xff, 0x75, 0x41, 0xc8, 0xff, 0x75, 0x41, 0xc8, 0xff, 0xdd, 0xd6, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc5, 0xad, 0xdb, 0xf3, 0x8d, 0x3b, 0xbe, 0xff, 0x8d, 0x3b, 0xbe, 0xff, 0x93, 0x3a, 0xbb, 0xf4, 0xaa, 0x35, 0xb0, 0x6c, 
  0x53, 0x49, 0xd7, 0x94, 0x53, 0x49, 0xd7, 0xff, 0x50, 0x4e, 0xd9, 0xf3, 0x46, 0x58, 0xdf, 0xf7, 0xcc, 0xd1, 0xf5, 0xec, 0xff, 0xff, 0xff, 0xff, 0xb7, 0xbc, 0xf1, 0xff, 0x3d, 0x57, 0xe3, 0xff, 0x3d, 0x57, 0xe3, 0xff, 0x3d, 0x57, 0xe3, 0xff, 0xa0, 0xa8, 0xee, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf6, 0xf7, 0xfd, 0xff, 0x84, 0x86, 0xe4, 0xff, 0x48, 0x4d, 0xdc, 0xff, 0x48, 0x4d, 0xdc, 0xff, 0x48, 0x4d, 0xdc, 0xff, 0x4d, 0x4f, 0xdc, 0xff, 0xa6, 0xa2, 0xe7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0xfd, 0xff, 0xff, 0x83, 0x7b, 0xdd, 0xff, 0x62, 0x4e, 0xd5, 0xff, 0x77, 0x47, 0xca, 0xff, 0x75, 0x40, 0xc8, 0xff, 0xdd, 0xd6, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc4, 0xaa, 0xda, 0xf0, 0x8d, 0x3b, 0xbe, 0xff, 0x8d, 0x3b, 0xbe, 0xff, 0x8d, 0x3b, 0xbe, 0xff, 0x94, 0x39, 0xbb, 0x6f, 
  0x4f, 0x4f, 0xda, 0x8f, 0x47, 0x5a, 0xdf, 0xf7, 0x3f, 0x61, 0xe4, 0xff, 0x3f, 0x61, 0xe4, 0xff, 0xc6, 0xcc, 0xf5, 0xf4, 0xff, 0xff, 0xff, 0xff, 0xbb, 0xc2, 0xf3, 0xff, 0x43, 0x60, 0xe4, 0xff, 0x3f, 0x5c, 0xe4, 0xff, 0x40, 0x5d, 0xe4, 0xff, 0x4b, 0x63, 0xe5, 0xff, 0xe0, 0xe3, 0xf9, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfa, 0xfa, 0xfe, 0xff, 0xc4, 0xc5, 0xf0, 0xff, 0xa8, 0xaa, 0xea, 0xff, 0xab, 0xac, 0xeb, 0xff, 0xd1, 0xd2, 0xf4, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc2, 0xbe, 0xed, 0xff, 0x57, 0x48, 0xd5, 0xff, 0x57, 0x48, 0xd5, 0xff, 0x64, 0x4c, 0xd4, 0xff, 0x76, 0x44, 0xc9, 0xff, 0xde, 0xd7, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xbd, 0xae, 0xdf, 0xe8, 0x8d, 0x3b, 0xbe, 0xff, 0x8d, 0x3b, 0xbe, 0xff, 0x8d, 0x3b, 0xbe, 0xff, 0x8e, 0x3a, 0xbd, 0x6f, 
  0x3f, 0x61, 0xe4, 0x94, 0x3f, 0x61, 0xe4, 0xff, 0x3f, 0x61, 0xe4, 0xff, 0x3f, 0x61, 0xe4, 0xff, 0xc0, 0xc6, 0xf3, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xc1, 0xc9, 0xf3, 0xff, 0x3f, 0x66, 0xe4, 0xff, 0x40, 0x66, 0xe4, 0xff, 0x40, 0x66, 0xe4, 0xff, 0x40, 0x66, 0xe4, 0xff, 0x4f, 0x71, 0xe6, 0xff, 0xd8, 0xde, 0xf8, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0xfe, 0xff, 0xff, 0xc4, 0xc5, 0xf1, 0xff, 0x56, 0x47, 0xd6, 0xff, 0x57, 0x48, 0xd5, 0xff, 0x57, 0x48, 0xd5, 0xff, 0x57, 0x48, 0xd5, 0xff, 0x6b, 0x4b, 0xd1, 0xff, 0xe3, 0xdb, 0xf2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xae, 0x9c, 0xdd, 0xec, 0x82, 0x3e, 0xc3, 0xf3, 0x8d, 0x3b, 0xbe, 0xff, 0x8d, 0x3b, 0xbe, 0xff, 0x8d, 0x3b, 0xbe, 0x6c, 
  0x3f, 0x61, 0xe4, 0x93, 0x3f, 0x61, 0xe4, 0xff, 0x3f, 0x61, 0xe4, 0xff, 0x3f, 0x61, 0xe4, 0xff, 0xb8, 0xbd, 0xf1, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xd2, 0xd9, 0xf6, 0xff, 0x55, 0x83, 0xe8, 0xff, 0x54, 0x83, 0xe8, 0xff, 0x54, 0x82, 0xe8, 0xff, 0x4b, 0x78, 0xe6, 0xff, 0x4d, 0x77, 0xe6, 0xff, 0x45, 0x6c, 0xe5, 0xff, 0x89, 0x9a, 0xeb, 0xff, 0xcd, 0xd3, 0xf6, 0xff, 0xe7, 0xea, 0xfa, 0xff, 0xe8, 0xea, 0xfa, 0xff, 0xc5, 0xc7, 0xf2, 0xff, 0x70, 0x79, 0xe4, 0xff, 0x41, 0x4f, 0xdf, 0xff, 0x4e, 0x52, 0xdd, 0xff, 0x57, 0x49, 0xd5, 0xff, 0x57, 0x48, 0xd5, 0xff, 0x57, 0x48, 0xd5, 0xff, 0x53, 0x43, 0xd4, 0xff, 0xeb, 0xe8, 0xf9, 0xff, 0xff, 0xff, 0xff, 0xff, 0x94, 0x74, 0xd5, 0xf3, 0x74, 0x42, 0xc9, 0xfb, 0x8c, 0x3b, 0xbe, 0xfc, 0x8d, 0x3b, 0xbe, 0xff, 0x8d, 0x3b, 0xbe, 0x6c, 
  0x3f, 0x61, 0xe4, 0x93, 0x3f, 0x61, 0xe4, 0xff, 0x3f, 0x61, 0xe4, 0xff, 0x40, 0x66, 0xe4, 0xf8, 0x83, 0xa2, 0xec, 0xe8, 0xff, 0xff, 0xff, 0xff, 0xef, 0xf4, 0xfd, 0xff, 0x43, 0x80, 0xe7, 0xff, 0x4e, 0x86, 0xe8, 0xff, 0x48, 0x82, 0xe7, 0xff, 0x50, 0x86, 0xe8, 0xff, 0x49, 0x7e, 0xe7, 0xff, 0x46, 0x7a, 0xe6, 0xff, 0x4f, 0x7c, 0xe7, 0xff, 0x44, 0x6c, 0xe5, 0xff, 0x3c, 0x64, 0xe4, 0xff, 0x44, 0x66, 0xe4, 0xff, 0x45, 0x55, 0xe0, 0xff, 0x41, 0x4f, 0xdf, 0xff, 0x41, 0x4f, 0xdf, 0xff, 0x41, 0x4f, 0xdf, 0xff, 0x55, 0x56, 0xdd, 0xff, 0x57, 0x48, 0xd5, 0xff, 0x57, 0x48, 0xd5, 0xff, 0x6f, 0x64, 0xda, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0xfc, 0xfe, 0xf8, 0x74, 0x46, 0xca, 0xff, 0x72, 0x42, 0xc9, 0xff, 0x81, 0x3e, 0xc4, 0xf4, 0x8d, 0x3b, 0xbe, 0xff, 0x8d, 0x3b, 0xbe, 0x6c, 
  0x3f, 0x61, 0xe4, 0x93, 0x3f, 0x61, 0xe4, 0xff, 0x44, 0x79, 0xe6, 0xf0, 0x47, 0x89, 0xe7, 0xfc, 0x47, 0x89, 0xe7, 0xff, 0xf1, 0xf5, 0xfd, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xb6, 0xcb, 0xf4, 0xff, 0x59, 0x97, 0xea, 0xff, 0x5b, 0x96, 0xea, 0xff, 0x4c, 0x8a, 0xe8, 0xff, 0x49, 0x87, 0xe7, 0xff, 0x50, 0x89, 0xe8, 0xff, 0x4c, 0x81, 0xe7, 0xff, 0x46, 0x7a, 0xe6, 0xff, 0x4b, 0x75, 0xe6, 0xff, 0x41, 0x67, 0xe4, 0xff, 0x46, 0x68, 0xe4, 0xff, 0x47, 0x57, 0xe0, 0xff, 0x41, 0x4f, 0xdf, 0xff, 0x41, 0x4f, 0xdf, 0xff, 0x42, 0x50, 0xdf, 0xff, 0x59, 0x52, 0xd9, 0xff, 0x58, 0x49, 0xd5, 0xff, 0xd4, 0xd2, 0xf2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe2, 0xde, 0xf3, 0xf0, 0x72, 0x42, 0xc9, 0xff, 0x72, 0x42, 0xc9, 0xff, 0x74, 0x42, 0xc9, 0xf7, 0x8c, 0x3b, 0xbe, 0xfb, 0x8d, 0x3b, 0xbe, 0x6b, 
  0x40, 0x64, 0xe4, 0x8b, 0x45, 0x80, 0xe6, 0xf8, 0x47, 0x89, 0xe7, 0xff, 0x47, 0x89, 0xe7, 0xff, 0x47, 0x89, 0xe7, 0xff, 0xad, 0xc5, 0xf2, 0xf0, 0xff, 0xff, 0xff, 0xff, 0xfd, 0xfe, 0xff, 0xff, 0xc1, 0xd6, 0xf5, 0xff, 0x58, 0xa0, 0xeb, 0xff, 0x46, 0x97, 0xea, 0xff, 0x50, 0x99, 0xea, 0xff, 0x54, 0x95, 0xea, 0xff, 0x49, 0x86, 0xe8, 0xff, 0x4f, 0x87, 0xe8, 0xff, 0x47, 0x7b, 0xe7, 0xff, 0x4d, 0x79, 0xe7, 0xff, 0x3f, 0x66, 0xe4, 0xff, 0x49, 0x69, 0xe4, 0xff, 0x45, 0x53, 0xdf, 0xff, 0x3e, 0x4d, 0xdf, 0xff, 0x39, 0x49, 0xdf, 0xff, 0x70, 0x77, 0xe4, 0xff, 0xd5, 0xd2, 0xf2, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0x8e, 0x81, 0xdc, 0xf8, 0x6e, 0x43, 0xcb, 0xef, 0x72, 0x42, 0xc9, 0xff, 0x72, 0x42, 0xc9, 0xff, 0x85, 0x3d, 0xc2, 0xf7, 0x8d, 0x3b, 0xbe, 0x67, 
  0x47, 0x89, 0xe7, 0x77, 0x47, 0x89, 0xe7, 0xff, 0x47, 0x89, 0xe7, 0xff, 0x48, 0x8b, 0xe7, 0xfc, 0x4c, 0x9a, 0xeb, 0xf8, 0x49, 0xa3, 0xec, 0xfc, 0xc8, 0xde, 0xf8, 0xef, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe8, 0xf2, 0xfc, 0xff, 0xde, 0xea, 0xfa, 0xff, 0xda, 0xe6, 0xf9, 0xff, 0xd9, 0xe4, 0xf9, 0xff, 0xd8, 0xe2, 0xf8, 0xff, 0xd9, 0xe1, 0xf8, 0xff, 0xd7, 0xdf, 0xf8, 0xff, 0xd8, 0xde, 0xf8, 0xff, 0xd8, 0xde, 0xf8, 0xff, 0xd9, 0xdc, 0xf7, 0xff, 0xdd, 0xdf, 0xf8, 0xff, 0xec, 0xed, 0xfc, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0xaa, 0xa2, 0xe4, 0xf7, 0x5f, 0x46, 0xd2, 0xff, 0x66, 0x45, 0xcf, 0xf7, 0x72, 0x42, 0xc9, 0xff, 0x72, 0x42, 0xc9, 0xff, 0x7b, 0x40, 0xc5, 0xf4, 0x8e, 0x3b, 0xbe, 0x54, 
  0x47, 0x89, 0xe7, 0x48, 0x47, 0x89, 0xe7, 0xff, 0x48, 0x8e, 0xe8, 0xfb, 0x4e, 0xa2, 0xec, 0xf8, 0x4e, 0xa4, 0xec, 0xff, 0x4e, 0xa5, 0xec, 0xfb, 0x4c, 0xaa, 0xec, 0xf8, 0xa0, 0xd0, 0xf3, 0xf0, 0xe3, 0xf0, 0xfb, 0xf8, 0xfe, 0xff, 0xff, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xfb, 0xff, 0xf8, 0xda, 0xda, 0xf4, 0xf7, 0x84, 0x82, 0xe0, 0xf8, 0x58, 0x49, 0xd5, 0xf8, 0x5f, 0x46, 0xd2, 0xff, 0x60, 0x46, 0xd2, 0xf8, 0x72, 0x42, 0xc9, 0xfc, 0x72, 0x42, 0xc9, 0xff, 0x72, 0x42, 0xc9, 0xfb, 0x8f, 0x3a, 0xbc, 0x1b, 
  0x18, 0x8a, 0xff, 0x00, 0x48, 0x8d, 0xe8, 0xd8, 0x4e, 0xa2, 0xec, 0xf7, 0x4e, 0xa4, 0xec, 0xff, 0x4f, 0xa9, 0xed, 0xf7, 0x52, 0xb6, 0xee, 0xf4, 0x52, 0xb8, 0xee, 0xf8, 0x53, 0xb9, 0xef, 0xec, 0x53, 0xb9, 0xef, 0xeb, 0x5a, 0xbc, 0xf0, 0xec, 0x85, 0xca, 0xf3, 0xe4, 0x9c, 0xd1, 0xf4, 0xe4, 0xa6, 0xcf, 0xf4, 0xe0, 0xa7, 0xcd, 0xf4, 0xec, 0xaa, 0xca, 0xf3, 0xe4, 0xa7, 0xc5, 0xf2, 0xe8, 0xa7, 0xc1, 0xf1, 0xe4, 0xa7, 0xba, 0xf0, 0xec, 0xa8, 0xb9, 0xf0, 0xe4, 0x99, 0xa8, 0xed, 0xec, 0x8b, 0x9a, 0xec, 0xe7, 0x66, 0x74, 0xe7, 0xf4, 0x3f, 0x53, 0xe2, 0xff, 0x49, 0x4d, 0xdc, 0xf7, 0x50, 0x4b, 0xd8, 0xff, 0x52, 0x4b, 0xd8, 0xf3, 0x5f, 0x46, 0xd2, 0xff, 0x5f, 0x46, 0xd2, 0xff, 0x6d, 0x43, 0xcb, 0xf0, 0x72, 0x42, 0xc9, 0xff, 0x72, 0x42, 0xc9, 0xb3, 0x51, 0x2d, 0x94, 0x00, 
  0x1f, 0x44, 0x7d, 0x00, 0x4e, 0xa3, 0xec, 0x4c, 0x4e, 0xa4, 0xec, 0xff, 0x4f, 0xab, 0xed, 0xf7, 0x52, 0xb7, 0xee, 0xf3, 0x53, 0xba, 0xef, 0xf7, 0x54, 0xc1, 0xf0, 0xf0, 0x57, 0xc9, 0xf2, 0xf7, 0x57, 0xcb, 0xf2, 0xfc, 0x57, 0xca, 0xf2, 0xfb, 0x55, 0xc4, 0xf1, 0xf0, 0x53, 0xbb, 0xef, 0xf7, 0x52, 0xb8, 0xee, 0xf0, 0x50, 0xad, 0xed, 0xf0, 0x4f, 0xa9, 0xed, 0xfb, 0x4a, 0x98, 0xea, 0xfc, 0x4a, 0x96, 0xea, 0xfb, 0x45, 0x80, 0xe6, 0xfb, 0x45, 0x7e, 0xe6, 0xff, 0x41, 0x68, 0xe4, 0xf4, 0x41, 0x66, 0xe4, 0xf4, 0x3d, 0x51, 0xe2, 0xfc, 0x3d, 0x51, 0xe2, 0xff, 0x41, 0x50, 0xe0, 0xf3, 0x50, 0x4b, 0xd8, 0xff, 0x50, 0x4b, 0xd8, 0xff, 0x5c, 0x46, 0xd3, 0xef, 0x5f, 0x46, 0xd2, 0xff, 0x67, 0x45, 0xce, 0xf8, 0x72, 0x42, 0xc9, 0xf7, 0x72, 0x42, 0xc9, 0x27, 0x39, 0x1e, 0x6b, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x40, 0x8e, 0xd0, 0x00, 0x4e, 0xa8, 0xed, 0x6c, 0x52, 0xb7, 0xee, 0xf3, 0x53, 0xba, 0xef, 0xf4, 0x57, 0xc8, 0xf1, 0xf8, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcb, 0xf2, 0xfc, 0x54, 0xbd, 0xef, 0xf7, 0x52, 0xb7, 0xef, 0xf0, 0x4f, 0xab, 0xed, 0xf4, 0x4d, 0xa4, 0xec, 0xf4, 0x4a, 0x97, 0xea, 0xff, 0x47, 0x8a, 0xe8, 0xf7, 0x45, 0x7e, 0xe6, 0xff, 0x43, 0x72, 0xe5, 0xf7, 0x41, 0x66, 0xe4, 0xff, 0x3f, 0x59, 0xe3, 0xef, 0x3d, 0x51, 0xe2, 0xff, 0x3d, 0x51, 0xe2, 0xff, 0x4f, 0x4b, 0xd8, 0xf8, 0x50, 0x4b, 0xd8, 0xff, 0x59, 0x49, 0xd5, 0xfb, 0x5f, 0x46, 0xd2, 0xff, 0x62, 0x46, 0xd1, 0xe8, 0x72, 0x42, 0xc9, 0x44, 0x52, 0x2e, 0xb3, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x8c, 0xc0, 0x00, 0x53, 0xb9, 0xef, 0x38, 0x56, 0xc7, 0xf1, 0xbf, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xcc, 0xf2, 0xff, 0x57, 0xca, 0xf2, 0xf8, 0x53, 0xba, 0xef, 0xf0, 0x51, 0xb3, 0xee, 0xf0, 0x4f, 0xaa, 0xed, 0xfc, 0x4a, 0x99, 0xea, 0xfc, 0x4a, 0x95, 0xea, 0xf4, 0x45, 0x7e, 0xe6, 0xff, 0x44, 0x78, 0xe5, 0xf0, 0x41, 0x66, 0xe4, 0xff, 0x40, 0x5f, 0xe3, 0xf0, 0x3d, 0x51, 0xe2, 0xff, 0x3d, 0x51, 0xe2, 0xff, 0x4c, 0x4d, 0xdb, 0xf8, 0x50, 0x4b, 0xd8, 0xff, 0x56, 0x49, 0xd6, 0xf3, 0x5f, 0x46, 0xd2, 0xa4, 0x5e, 0x47, 0xd2, 0x23, 0x47, 0x2e, 0xb1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2c, 0x55, 0x60, 0x00, 0x3d, 0x95, 0xb2, 0x00, 0x58, 0xcb, 0xf4, 0x18, 0x57, 0xcc, 0xf2, 0x4c, 0x57, 0xcc, 0xf2, 0x5c, 0x57, 0xcc, 0xf2, 0x63, 0x57, 0xcc, 0xf2, 0x63, 0x57, 0xcc, 0xf2, 0x64, 0x57, 0xcc, 0xf2, 0x64, 0x57, 0xcc, 0xf2, 0x67, 0x55, 0xc1, 0xf0, 0x64, 0x52, 0xb7, 0xee, 0x58, 0x4f, 0xaa, 0xed, 0x64, 0x4c, 0x9d, 0xeb, 0x63, 0x4a, 0x97, 0xea, 0x67, 0x46, 0x81, 0xe7, 0x63, 0x45, 0x7e, 0xe6, 0x64, 0x41, 0x66, 0xe4, 0x67, 0x41, 0x63, 0xe4, 0x63, 0x3d, 0x53, 0xe2, 0x67, 0x3d, 0x53, 0xe2, 0x64, 0x4b, 0x4d, 0xdb, 0x5c, 0x50, 0x4b, 0xd8, 0x47, 0x50, 0x4c, 0xd9, 0x10, 0x41, 0x33, 0x99, 0x00, 0x2d, 0x23, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
#endif
};

const lv_img_dsc_t instagram_32px = {
  .header.always_zero = 0,
  .header.w = 32,
  .header.h = 32,
  .data_size = 1024 * LV_IMG_PX_SIZE_ALPHA_BYTE,
  .header.cf = LV_IMG_CF_TRUE_COLOR_ALPHA,
  .data = instagram_32px_map,
};

